#!/bin/bash
# for running: uvicorn toardb.toardb:app --reload

curl http://127.0.0.1:8000/variables/?limit=3
curl http://127.0.0.1:8000/variables/id/2
curl http://127.0.0.1:8000/variables/id/99
curl http://127.0.0.1:8000/variables/CO
curl -X POST -H "Content-Type:application/json" -d '{"name": "sabinene", "longname": "sabinene", "displayname": "Sabinene", "cf_standardname": "mole_fraction_of_sabinene_in_air", "units": "nmol mol-1", "chemical_formula": "C10H16"}' http://127.0.0.1:8000/variables/

curl http://127.0.0.1:8000/contacts/organisations/
curl http://127.0.0.1:8000/contacts/organisations/id/36
curl http://127.0.0.1:8000/contacts/organisations/id/99
curl http://127.0.0.1:8000/contacts/organisations/UBA
curl -X POST -H "Content-Type:application/json" -d '{"organisation": {"name": "FZJ", "longname": "Forschungszentrum Test", "kind": "Research", "city": "Jülich", "postcode": "52425", "street_address": "Wilhelm-Johnen-Straße", "country": "Germany", "homepage": "https://www.fz-juelich.de"}}' http://127.0.0.1:8000/contacts/organisations/
curl http://127.0.0.1:8000/contacts/persons/
curl http://127.0.0.1:8000/contacts/persons/id/8
curl http://127.0.0.1:8000/contacts/persons/id/99
curl "http://127.0.0.1:8000/contacts/persons/Martin%20Schultz"
curl -X POST -H "Content-Type:application/json" -d '{"person": {"name": "Sabine Schröder", "email": "s.schroeder@fz-juelich.de", "phone": "+49-2461-61-6397", "isprivate": true}}' http://127.0.0.1:8000/contacts/persons/
curl "http://127.0.0.1:8000/contacts/persons/Sabine%20Schr%C3%B6der"

curl http://127.0.0.1:8000/contacts/

curl http://127.0.0.1:8000/stationmeta_core/
curl http://127.0.0.1:8000/stationmeta/
curl http://127.0.0.1:8000/stationmeta_core/DEUB001
curl http://127.0.0.1:8000/stationmeta/DEUB001
# station upload without nested fields
curl -X POST -H "Content-Type:application/json" -d '{"stationmeta": {"codes":["China11"],"name":"Mount Tai","coordinates":{"lat":36.256,"lng":17.106,"alt":1534.0},"country":"China","state":"Shandong Sheng","type_of_environment":"Background","type_of_area":"Rural","category":"","timezone":"Asia/Shanghai","additional_metadata":"{}"}}' "http://127.0.0.1:8000/stationmeta/"
# (nested) upload including 'global' (not defining all metadata -- getting the rest from default values) with human readable fields
curl -X POST -H "Content-Type:application/json" -d '{"stationmeta": {"codes":["CHHKG015"],"name":"Shatin","coordinates":{"lat":22.3765,"lng":114.1847,"alt":25},"country":"China","state":"New Territories","type_of_environment":"Unknown","type_of_area":"Suburban","category":"","timezone":"Asia/Hong_Kong","additional_metadata":"{}", "roles": [{"role": "PointOfContact", "contact_id": 43, "status": "active"},{"role": "PrincipalInvestigator", "contact_id": 41, "status": "active"}], "globalmeta": {"climatic_zone": "WarmTemperateMoist"}}}' http://127.0.0.1:8000/stationmeta/ 

curl http://127.0.0.1:8000/timeseries/
curl http://127.0.0.1:8000/timeseries/97
# timeseries upload with (nested) human readable fields
curl -X POST -H "Content-Type:application/json" -d '{"timeseries": {"label": "CMA5", "order": 1, "access_rights": "ByAttribution", "sampling_frequency": "Hourly", "aggregation": "Mean", "source": "Measurement", "data_start_date": "2003-09-07T15:30:00+02:00", "data_end_date": "2016-12-31T14:30:00+01:00", "measurement_method": "UVAbsorption", "sampling_height": 7.0, "date_added": "2020-05-15T15:30:00+02:00", "date_modified": "2020-05-16T09:30:00+02:00", "station_id": 60, "variable_id": 7, "additional_metadata":"{}", "roles": [{"role": "PointOfContact", "contact_id": 43, "status": "active"},{"role": "Originator", "contact_id": 41, "status": "active"}]}}' http://127.0.0.1:8000/timeseries/
# TBD: use person_email (instead of person_id) to identify persons, f. ex. "person_email": "s.schroeder@fz-juelich.de"

curl -X POST -H 'Content-Type: multipart/form-data; charset=utf-8; boundary=__X_PAW_BOUNDARY__' -F "file=@o3_CO002_2012_2017_v1-0.dat" "http://127.0.0.1:8000/data/"
