--
-- PostgreSQL database dump
--

-- Dumped from database version 10.3 (Ubuntu 10.3-1)
-- Dumped by pg_dump version 10.3 (Ubuntu 10.3-1)

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', '', false);
SET check_function_bodies = false;
SET client_min_messages = warning;
SET row_security = off;

--
-- Name: postgis; Type: SCHEMA; Schema: -; Owner: toarcurator
--

CREATE SCHEMA postgis;


ALTER SCHEMA postgis OWNER TO toarcurator;

--
-- Name: tiger; Type: SCHEMA; Schema: -; Owner: toarcurator
--

CREATE SCHEMA tiger;


ALTER SCHEMA tiger OWNER TO toarcurator;

--
-- Name: tiger_data; Type: SCHEMA; Schema: -; Owner: toarcurator
--

CREATE SCHEMA tiger_data;


ALTER SCHEMA tiger_data OWNER TO toarcurator;

--
-- Name: topology; Type: SCHEMA; Schema: -; Owner: toarcurator
--

CREATE SCHEMA topology;


ALTER SCHEMA topology OWNER TO toarcurator;

--
-- Name: SCHEMA topology; Type: COMMENT; Schema: -; Owner: toarcurator
--

COMMENT ON SCHEMA topology IS 'PostGIS Topology schema';


--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


--
-- Name: address_standardizer; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS address_standardizer WITH SCHEMA public;


--
-- Name: EXTENSION address_standardizer; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION address_standardizer IS 'Used to parse an address into constituent elements. Generally used to support geocoding address normalization step.';


--
-- Name: address_standardizer_data_us; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS address_standardizer_data_us WITH SCHEMA public;


--
-- Name: EXTENSION address_standardizer_data_us; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION address_standardizer_data_us IS 'Address Standardizer US dataset example';


--
-- Name: fuzzystrmatch; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS fuzzystrmatch WITH SCHEMA public;


--
-- Name: EXTENSION fuzzystrmatch; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION fuzzystrmatch IS 'determine similarities and distance between strings';


--
-- Name: postgis; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS postgis WITH SCHEMA postgis;


--
-- Name: EXTENSION postgis; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION postgis IS 'PostGIS geometry, geography, and raster spatial types and functions';


--
-- Name: postgis_tiger_geocoder; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS postgis_tiger_geocoder WITH SCHEMA tiger;


--
-- Name: EXTENSION postgis_tiger_geocoder; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION postgis_tiger_geocoder IS 'PostGIS tiger geocoder and reverse geocoder';


--
-- Name: postgis_topology; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS postgis_topology WITH SCHEMA topology;


--
-- Name: EXTENSION postgis_topology; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION postgis_topology IS 'PostGIS topology spatial types and functions';


--
-- Name: toar_controlled_vocabulary; Type: EXTENSION; Schema: -; Owner: 
--

CREATE EXTENSION IF NOT EXISTS toar_controlled_vocabulary WITH SCHEMA public;


--
-- Name: EXTENSION toar_controlled_vocabulary; Type: COMMENT; Schema: -; Owner: 
--

COMMENT ON EXTENSION toar_controlled_vocabulary IS 'TOAR controlled vocabulary';


SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: auth_user; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.auth_user (
    id integer NOT NULL,
    password character varying(128) NOT NULL,
    last_login timestamp with time zone,
    is_superuser boolean NOT NULL,
    username character varying(150) NOT NULL,
    first_name character varying(30) NOT NULL,
    last_name character varying(150) NOT NULL,
    email character varying(254) NOT NULL,
    is_staff boolean NOT NULL,
    is_active boolean NOT NULL,
    date_joined timestamp with time zone NOT NULL
);


ALTER TABLE public.auth_user OWNER TO toarcurator;

--
-- Name: auth_user_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.auth_user_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.auth_user_id_seq OWNER TO toarcurator;

--
-- Name: auth_user_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.auth_user_id_seq OWNED BY public.auth_user.id;


--
-- Name: contacts; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.contacts (
    id integer NOT NULL,
    person_id integer,
    organisation_id integer,
    CONSTRAINT ck_contact CHECK ((((person_id > 0) AND (organisation_id = 0)) OR ((person_id = 0) AND (organisation_id > 0))))
);


ALTER TABLE public.contacts OWNER TO toarcurator;

--
-- Name: contacts_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.contacts_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.contacts_id_seq OWNER TO toarcurator;

--
-- Name: contacts_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.contacts_id_seq OWNED BY public.contacts.id;


--
-- Name: data; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.data (
    datetime timestamp with time zone NOT NULL,
    value double precision NOT NULL,
    flags integer NOT NULL,
    timeseries_id integer NOT NULL,
    CONSTRAINT data_flags_check CHECK ((flags >= 0))
);


ALTER TABLE public.data OWNER TO toarcurator;

--
-- Name: organisations; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.organisations (
    id integer NOT NULL,
    name character varying(32) NOT NULL,
    longname character varying(128) NOT NULL,
    kind integer NOT NULL,
    city character varying(64) NOT NULL,
    postcode character varying(16) NOT NULL,
    street_address character varying(128) NOT NULL,
    country character varying(64) NOT NULL,
    homepage character varying(200) NOT NULL,
    CONSTRAINT organisations_kind_check CHECK ((kind >= 0))
);


ALTER TABLE public.organisations OWNER TO toarcurator;

--
-- Name: organisations_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.organisations_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.organisations_id_seq OWNER TO toarcurator;

--
-- Name: organisations_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.organisations_id_seq OWNED BY public.organisations.id;


--
-- Name: persons; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.persons (
    id integer NOT NULL,
    name character varying(64) NOT NULL,
    email character varying(128) NOT NULL,
    phone character varying(32) NOT NULL,
    isprivate boolean NOT NULL
);


ALTER TABLE public.persons OWNER TO toarcurator;

--
-- Name: persons_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.persons_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.persons_id_seq OWNER TO toarcurator;

--
-- Name: persons_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.persons_id_seq OWNED BY public.persons.id;


--
-- Name: stationmeta_annotations; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_annotations (
    id integer NOT NULL,
    kind integer NOT NULL,
    text text NOT NULL,
    date_added timestamp with time zone NOT NULL,
    approved boolean NOT NULL,
    contributor_id integer NOT NULL,
    CONSTRAINT stationmeta_annotations_kind_check CHECK ((kind >= 0))
);


ALTER TABLE public.stationmeta_annotations OWNER TO toarcurator;

--
-- Name: stationmeta_annotations_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_annotations_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_annotations_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_annotations_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_annotations_id_seq OWNED BY public.stationmeta_annotations.id;


--
-- Name: stationmeta_aux_doc; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_aux_doc (
    id integer NOT NULL,
    resource_description text NOT NULL,
    date_added timestamp with time zone NOT NULL,
    resource character varying(100) NOT NULL,
    station_id integer
);


ALTER TABLE public.stationmeta_aux_doc OWNER TO toarcurator;

--
-- Name: stationmeta_aux_doc_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_aux_doc_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_aux_doc_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_aux_doc_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_aux_doc_id_seq OWNED BY public.stationmeta_aux_doc.id;


--
-- Name: stationmeta_aux_image; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_aux_image (
    id integer NOT NULL,
    resource_description text NOT NULL,
    date_added timestamp with time zone NOT NULL,
    resource character varying(100) NOT NULL,
    image_height integer NOT NULL,
    image_width integer NOT NULL,
    station_id integer,
    CONSTRAINT stationmeta_aux_image_image_height_check CHECK ((image_height >= 0)),
    CONSTRAINT stationmeta_aux_image_image_width_check CHECK ((image_width >= 0))
);


ALTER TABLE public.stationmeta_aux_image OWNER TO toarcurator;

--
-- Name: stationmeta_aux_image_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_aux_image_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_aux_image_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_aux_image_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_aux_image_id_seq OWNED BY public.stationmeta_aux_image.id;


--
-- Name: stationmeta_aux_url; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_aux_url (
    id integer NOT NULL,
    resource_description text NOT NULL,
    date_added timestamp with time zone NOT NULL,
    resource character varying(200) NOT NULL,
    station_id integer
);


ALTER TABLE public.stationmeta_aux_url OWNER TO toarcurator;

--
-- Name: stationmeta_aux_url_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_aux_url_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_aux_url_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_aux_url_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_aux_url_id_seq OWNED BY public.stationmeta_aux_url.id;


--
-- Name: stationmeta_core; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_core (
    id integer NOT NULL,
    codes character varying(16)[],
    name character varying(128) NOT NULL,
    coordinates postgis.geometry(PointZ,4326) NOT NULL,
    country character varying(128) NOT NULL,
    state character varying(128) NOT NULL,
    coordinate_validation_status integer NOT NULL,
    coordinate_validation_date timestamp with time zone NOT NULL,
    type_of_environment integer NOT NULL,
    type_of_area integer NOT NULL,
    timezone character varying(64) NOT NULL,
    additional_metadata jsonb NOT NULL,
    coordinate_validator_id integer NOT NULL,
    CONSTRAINT stationmeta_core_coordinate_validation_status_check CHECK ((coordinate_validation_status >= 0)),
    CONSTRAINT stationmeta_core_type_of_area_check CHECK ((type_of_area >= 0)),
    CONSTRAINT stationmeta_core_type_of_environment_check CHECK ((type_of_environment >= 0))
);


ALTER TABLE public.stationmeta_core OWNER TO toarcurator;

--
-- Name: stationmeta_core_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_core_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_core_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_core_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_core_id_seq OWNED BY public.stationmeta_core.id;


--
-- Name: stationmeta_core_stationmeta_annotations; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_core_stationmeta_annotations (
    station_id integer NOT NULL,
    annotation_id integer NOT NULL
);


ALTER TABLE public.stationmeta_core_stationmeta_annotations OWNER TO toarcurator;

--
-- Name: stationmeta_core_stationmeta_roles; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_core_stationmeta_roles (
    station_id integer NOT NULL,
    role_id integer NOT NULL
);


ALTER TABLE public.stationmeta_core_stationmeta_roles OWNER TO toarcurator;

--
-- Name: stationmeta_global; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_global (
    id integer NOT NULL,
    population_density_year2010 double precision DEFAULT '-1.0'::numeric NOT NULL,
    max_population_density_25km_year2010 double precision DEFAULT '-1.0'::numeric NOT NULL,
    climatic_zone integer DEFAULT '-1'::integer NOT NULL,
    nightlight_1km_year2013 double precision DEFAULT '-999.0'::numeric NOT NULL,
    nightlight_5km_year2013 double precision DEFAULT '-999.0'::numeric NOT NULL,
    max_nightlight_25km_year2013 double precision DEFAULT '-999.0'::numeric NOT NULL,
    wheat_production_year2000 double precision DEFAULT '-999.0'::numeric NOT NULL,
    rice_production_year2000 double precision DEFAULT '-999.0'::numeric NOT NULL,
    edgar_htap_v2_nox_emissions_year2010 double precision DEFAULT '-999.0'::numeric NOT NULL,
    omi_no2_column_years2011to2015 double precision DEFAULT '-999.0'::numeric NOT NULL,
    htap_region_tier1 integer DEFAULT '-1'::integer NOT NULL,
    etopo_alt double precision DEFAULT '-999.0'::numeric NOT NULL,
    etopo_min_alt_5km double precision DEFAULT '-999.0'::numeric NOT NULL,
    etopo_relative_alt double precision DEFAULT '-999.0'::numeric NOT NULL,
    dominant_landcover_year2012 integer DEFAULT '-1'::integer NOT NULL,
    toar1_category integer DEFAULT '-1'::integer NOT NULL,
    station_id integer NOT NULL
);


ALTER TABLE public.stationmeta_global OWNER TO toarcurator;

--
-- Name: stationmeta_global_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_global_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_global_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_global_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_global_id_seq OWNED BY public.stationmeta_global.id;


--
-- Name: stationmeta_global_services; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_global_services (
    id integer NOT NULL,
    variable_name character varying(64) NOT NULL,
    result_type integer NOT NULL,
    result_nvalues integer NOT NULL,
    service_valid_year integer,
    service_url character varying(200) NOT NULL,
    station_id integer NOT NULL,
    CONSTRAINT stationmeta_global_services_result_nvalues_check CHECK ((result_nvalues >= 0)),
    CONSTRAINT stationmeta_global_services_result_type_check CHECK ((result_type >= 0)),
    CONSTRAINT stationmeta_global_services_service_valid_year_check CHECK ((service_valid_year >= 0))
);


ALTER TABLE public.stationmeta_global_services OWNER TO toarcurator;

--
-- Name: stationmeta_global_services_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_global_services_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_global_services_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_global_services_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_global_services_id_seq OWNED BY public.stationmeta_global_services.id;


--
-- Name: stationmeta_roles; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.stationmeta_roles (
    id integer NOT NULL,
    role integer NOT NULL,
    status integer NOT NULL,
    contact_id integer NOT NULL,
    CONSTRAINT stationmeta_roles_role_check CHECK ((role >= 0)),
    CONSTRAINT stationmeta_roles_status_check CHECK ((status >= 0))
);


ALTER TABLE public.stationmeta_roles OWNER TO toarcurator;

--
-- Name: stationmeta_roles_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.stationmeta_roles_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.stationmeta_roles_id_seq OWNER TO toarcurator;

--
-- Name: stationmeta_roles_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.stationmeta_roles_id_seq OWNED BY public.stationmeta_roles.id;


--
-- Name: timeseries; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.timeseries (
    id integer NOT NULL,
    label character varying(128) NOT NULL,
    "order" integer NOT NULL,
    access_rights integer NOT NULL,
    sampling_frequency integer NOT NULL,
    aggregation integer NOT NULL,
    data_start_date timestamp with time zone NOT NULL,
    data_end_date timestamp with time zone NOT NULL,
    sampling_height double precision NOT NULL,
    additional_metadata jsonb NOT NULL,
    date_added timestamp with time zone DEFAULT now() NOT NULL,
    date_modified timestamp with time zone DEFAULT now() NOT NULL,
    station_id integer,
    variable_id integer,
    source integer DEFAULT 1 NOT NULL,
    measurement_method integer DEFAULT 1 NOT NULL,
    programme_id integer DEFAULT 0 NOT NULL,
    CONSTRAINT timeseries_access_rights_check CHECK ((access_rights >= 0)),
    CONSTRAINT timeseries_aggregation_check CHECK ((aggregation >= 0)),
    CONSTRAINT timeseries_order_check CHECK (("order" >= 0)),
    CONSTRAINT timeseries_sampling_frequency_check CHECK ((sampling_frequency >= 0))
);


ALTER TABLE public.timeseries OWNER TO toarcurator;

--
-- Name: timeseries_annotations; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.timeseries_annotations (
    id integer NOT NULL,
    kind integer NOT NULL,
    text text NOT NULL,
    date_added timestamp with time zone NOT NULL,
    approved boolean NOT NULL,
    contributor_id integer NOT NULL,
    CONSTRAINT timeseries_annotations_kind_check CHECK ((kind >= 0))
);


ALTER TABLE public.timeseries_annotations OWNER TO toarcurator;

--
-- Name: timeseries_annotations_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.timeseries_annotations_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.timeseries_annotations_id_seq OWNER TO toarcurator;

--
-- Name: timeseries_annotations_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.timeseries_annotations_id_seq OWNED BY public.timeseries_annotations.id;


--
-- Name: timeseries_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.timeseries_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.timeseries_id_seq OWNER TO toarcurator;

--
-- Name: timeseries_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.timeseries_id_seq OWNED BY public.timeseries.id;


--
-- Name: timeseries_programmes; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.timeseries_programmes (
    id integer NOT NULL,
    name character varying(32) NOT NULL,
    longname character varying(128) NOT NULL,
    homepage character varying(200) NOT NULL,
    description text NOT NULL
);


ALTER TABLE public.timeseries_programmes OWNER TO toarcurator;

--
-- Name: timeseries_programmes_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.timeseries_programmes_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.timeseries_programmes_id_seq OWNER TO toarcurator;

--
-- Name: timeseries_programmes_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.timeseries_programmes_id_seq OWNED BY public.timeseries_programmes.id;


--
-- Name: timeseries_roles; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.timeseries_roles (
    id integer NOT NULL,
    role integer NOT NULL,
    status integer NOT NULL,
    contact_id integer NOT NULL,
    CONSTRAINT timeseries_roles_role_check CHECK ((role >= 0)),
    CONSTRAINT timeseries_roles_status_check CHECK ((status >= 0))
);


ALTER TABLE public.timeseries_roles OWNER TO toarcurator;

--
-- Name: timeseries_roles_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.timeseries_roles_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.timeseries_roles_id_seq OWNER TO toarcurator;

--
-- Name: timeseries_roles_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.timeseries_roles_id_seq OWNED BY public.timeseries_roles.id;


--
-- Name: timeseries_timeseries_annotations; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.timeseries_timeseries_annotations (
    timeseries_id integer NOT NULL,
    annotation_id integer NOT NULL
);


ALTER TABLE public.timeseries_timeseries_annotations OWNER TO toarcurator;

--
-- Name: timeseries_timeseries_roles; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.timeseries_timeseries_roles (
    timeseries_id integer NOT NULL,
    role_id integer NOT NULL
);


ALTER TABLE public.timeseries_timeseries_roles OWNER TO toarcurator;

--
-- Name: variables; Type: TABLE; Schema: public; Owner: toarcurator
--

CREATE TABLE public.variables (
    id integer NOT NULL,
    name character varying(32) NOT NULL,
    longname character varying(128) NOT NULL,
    displayname character varying(128) NOT NULL,
    cf_standardname character varying(128) NOT NULL,
    units character varying(64) NOT NULL,
    chemical_formula character varying(128) NOT NULL
);


ALTER TABLE public.variables OWNER TO toarcurator;

--
-- Name: variables_id_seq; Type: SEQUENCE; Schema: public; Owner: toarcurator
--

CREATE SEQUENCE public.variables_id_seq
    AS integer
    START WITH 1
    INCREMENT BY 1
    NO MINVALUE
    NO MAXVALUE
    CACHE 1;


ALTER TABLE public.variables_id_seq OWNER TO toarcurator;

--
-- Name: variables_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: toarcurator
--

ALTER SEQUENCE public.variables_id_seq OWNED BY public.variables.id;


--
-- Name: auth_user id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.auth_user ALTER COLUMN id SET DEFAULT nextval('public.auth_user_id_seq'::regclass);


--
-- Name: contacts id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.contacts ALTER COLUMN id SET DEFAULT nextval('public.contacts_id_seq'::regclass);


--
-- Name: organisations id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.organisations ALTER COLUMN id SET DEFAULT nextval('public.organisations_id_seq'::regclass);


--
-- Name: persons id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.persons ALTER COLUMN id SET DEFAULT nextval('public.persons_id_seq'::regclass);


--
-- Name: stationmeta_annotations id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_annotations ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_annotations_id_seq'::regclass);


--
-- Name: stationmeta_aux_doc id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_doc ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_aux_doc_id_seq'::regclass);


--
-- Name: stationmeta_aux_image id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_image ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_aux_image_id_seq'::regclass);


--
-- Name: stationmeta_aux_url id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_url ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_aux_url_id_seq'::regclass);


--
-- Name: stationmeta_core id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_core_id_seq'::regclass);


--
-- Name: stationmeta_global id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_global_id_seq'::regclass);


--
-- Name: stationmeta_global_services id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global_services ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_global_services_id_seq'::regclass);


--
-- Name: stationmeta_roles id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_roles ALTER COLUMN id SET DEFAULT nextval('public.stationmeta_roles_id_seq'::regclass);


--
-- Name: timeseries id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries ALTER COLUMN id SET DEFAULT nextval('public.timeseries_id_seq'::regclass);


--
-- Name: timeseries_annotations id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_annotations ALTER COLUMN id SET DEFAULT nextval('public.timeseries_annotations_id_seq'::regclass);


--
-- Name: timeseries_programmes id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_programmes ALTER COLUMN id SET DEFAULT nextval('public.timeseries_programmes_id_seq'::regclass);


--
-- Name: timeseries_roles id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_roles ALTER COLUMN id SET DEFAULT nextval('public.timeseries_roles_id_seq'::regclass);


--
-- Name: variables id; Type: DEFAULT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.variables ALTER COLUMN id SET DEFAULT nextval('public.variables_id_seq'::regclass);


--
-- Data for Name: spatial_ref_sys; Type: TABLE DATA; Schema: postgis; Owner: toarcurator
--

COPY postgis.spatial_ref_sys (srid, auth_name, auth_srid, srtext, proj4text) FROM stdin;
\.


--
-- Data for Name: auth_user; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.auth_user (id, password, last_login, is_superuser, username, first_name, last_name, email, is_staff, is_active, date_joined) FROM stdin;
2	pbkdf2_sha256$120000$e6mCx4B1ReAJ$oPEJck70m4p1i6TpAYMehDJ3h/DgSiqEa7juOAM2u3g=	\N	f	AnonymousUser	Anonymous	User		f	f	2020-03-03 13:32:29+01
1	pbkdf2_sha256$120000$rDFZcfbC78Lo$mkXG3yrd5nu7aEOSc8wK3O+61vRXHzywbj1ZnjqP/lo=	2020-03-12 11:48:36.61661+01	t	sschroeder			s.schroeder@fz-juelich.de	t	t	2020-03-03 13:30:11.393341+01
\.


--
-- Data for Name: contacts; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.contacts (id, person_id, organisation_id) FROM stdin;
39	0	35
40	0	36
\.


--
-- Data for Name: data; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.data (datetime, value, flags, timeseries_id) FROM stdin;
1990-01-01 01:00:00+01	1.07766999999999991	0	94
1990-01-01 02:00:00+01	0.827045999999999948	0	94
1990-01-01 03:00:00+01	1.00248000000000004	0	94
1990-01-01 04:00:00+01	1.10272999999999999	0	94
1990-01-12 16:00:00+01	19.3729000000000013	0	94
1990-01-12 17:00:00+01	18.295300000000001	0	94
1990-01-12 18:00:00+01	21.5533000000000001	0	94
1990-01-12 19:00:00+01	24.9366999999999983	0	94
1990-01-12 20:00:00+01	24.6610000000000014	0	94
1990-01-12 21:00:00+01	23.1572999999999993	0	94
1990-01-12 22:00:00+01	12.5561000000000007	0	94
1990-01-12 23:00:00+01	15.6387	0	94
1990-01-13 00:00:00+01	13.0071999999999992	0	94
1990-01-13 01:00:00+01	8.87195	0	94
1990-01-13 02:00:00+01	4.81189999999999962	0	94
1990-01-13 03:00:00+01	5.21290000000000031	0	94
1990-01-13 04:00:00+01	8.32057999999999964	0	94
1990-01-13 05:00:00+01	7.79427999999999965	0	94
1990-01-13 06:00:00+01	7.41835000000000022	0	94
1990-01-13 07:00:00+01	7.54366000000000003	0	94
1990-01-13 08:00:00+01	24.6109000000000009	0	94
1990-01-13 09:00:00+01	29.7987000000000002	0	94
1990-01-13 10:00:00+01	29.0217999999999989	0	94
1990-01-13 11:00:00+01	27.3426000000000009	0	94
1990-01-13 12:00:00+01	27.9191000000000003	0	94
1990-01-13 13:00:00+01	28.0694000000000017	0	94
1990-01-13 14:00:00+01	28.4453999999999994	0	94
1990-01-13 15:00:00+01	29.247399999999999	0	94
1990-01-13 16:00:00+01	29.4980000000000011	0	94
1990-01-13 17:00:00+01	28.6708999999999996	0	94
1990-01-13 18:00:00+01	29.648299999999999	0	94
1990-01-13 19:00:00+01	29.4728999999999992	0	94
1990-01-13 20:00:00+01	29.247399999999999	0	94
1990-01-13 21:00:00+01	29.5481000000000016	0	94
1990-01-13 22:00:00+01	32.1544999999999987	0	94
1990-01-13 23:00:00+01	27.8439000000000014	0	94
1990-01-14 00:00:00+01	22.4304999999999986	0	94
1990-01-14 01:00:00+01	12.9320000000000004	0	94
1990-01-14 02:00:00+01	16.5409000000000006	0	94
1990-01-14 03:00:00+01	18.3202999999999996	0	94
1990-01-14 04:00:00+01	18.6210999999999984	0	94
1990-01-14 05:00:00+01	20.4756999999999998	0	94
1990-01-14 06:00:00+01	18.0445999999999991	0	94
1990-01-14 07:00:00+01	14.6111000000000004	0	94
1990-01-14 08:00:00+01	17.2426999999999992	0	94
1990-01-14 09:00:00+01	13.8092000000000006	0	94
1990-01-14 10:00:00+01	12.8316999999999997	0	94
1990-01-14 11:00:00+01	9.8493700000000004	0	94
1990-01-14 12:00:00+01	10.8268000000000004	0	94
1990-01-14 13:00:00+01	13.2577999999999996	0	94
1990-01-14 14:00:00+01	15.2628000000000004	0	94
1990-01-14 15:00:00+01	13.2828999999999997	0	94
1990-01-14 16:00:00+01	8.9972600000000007	0	94
1990-01-14 17:00:00+01	6.64142999999999972	0	94
1990-01-14 18:00:00+01	6.06500000000000039	0	94
1990-01-14 19:00:00+01	9.79923999999999928	0	94
1990-01-14 20:00:00+01	14.5609999999999999	0	94
1990-01-14 21:00:00+01	15.0873000000000008	0	94
1990-01-14 22:00:00+01	13.9093999999999998	0	94
1990-01-14 23:00:00+01	12.7315000000000005	0	94
1990-01-15 00:00:00+01	14.0347000000000008	0	94
1990-01-15 01:00:00+01	15.6135999999999999	0	94
1990-01-15 02:00:00+01	17.1173000000000002	0	94
1990-01-15 03:00:00+01	17.9444000000000017	0	94
1990-01-15 04:00:00+01	17.5433999999999983	0	94
1990-01-15 05:00:00+01	13.6087000000000007	0	94
1990-01-15 06:00:00+01	10.1501000000000001	0	94
1990-01-15 07:00:00+01	7.74415999999999993	0	94
1990-01-15 11:00:00+01	17.5685000000000002	0	94
1990-01-15 12:00:00+01	21.9041999999999994	0	94
1990-01-15 13:00:00+01	23.1824000000000012	0	94
1990-01-15 14:00:00+01	24.7362000000000002	0	94
1990-01-15 15:00:00+01	25.8640000000000008	0	94
1990-01-15 16:00:00+01	25.2123999999999988	0	94
1990-01-15 17:00:00+01	23.2325000000000017	0	94
1990-01-15 18:00:00+01	21.6785999999999994	0	94
1990-01-15 19:00:00+01	19.0721999999999987	0	94
1990-01-15 20:00:00+01	15.8140999999999998	0	94
1990-01-15 21:00:00+01	13.2077000000000009	0	94
1990-01-15 22:00:00+01	13.3079000000000001	0	94
1990-01-15 23:00:00+01	13.5084	0	94
1990-01-16 00:00:00+01	11.7790999999999997	0	94
1991-09-03 16:00:00+02	58.1940000000000026	0	95
1991-09-03 17:00:00+02	54.5600000000000023	0	95
1991-09-03 18:00:00+02	52.730400000000003	0	95
1991-09-03 19:00:00+02	50.0488	0	95
1991-09-03 20:00:00+02	48.9962000000000018	0	95
1991-09-03 21:00:00+02	49.0964999999999989	0	95
1991-09-03 22:00:00+02	36.0140999999999991	0	95
1991-09-03 23:00:00+02	37.2672000000000025	0	95
1991-09-04 00:00:00+02	23.357800000000001	0	95
1991-09-04 01:00:00+02	23.8089000000000013	0	95
1991-09-04 02:00:00+02	23.6585000000000001	0	95
1991-09-04 03:00:00+02	29.6734000000000009	0	95
1991-09-04 04:00:00+02	32.3299999999999983	0	95
1991-09-04 05:00:00+02	30.2748999999999988	0	95
1991-09-04 06:00:00+02	20.9517999999999986	0	95
1991-09-04 07:00:00+02	19.0220999999999982	0	95
1991-09-04 08:00:00+02	17.5934999999999988	0	95
1991-09-04 09:00:00+02	19.9242999999999988	0	95
1991-09-04 10:00:00+02	30.8012000000000015	0	95
1991-09-04 11:00:00+02	37.2421000000000006	0	95
1991-09-04 12:00:00+02	34.8111000000000033	0	95
1991-09-04 13:00:00+02	35.7383999999999986	0	95
1991-09-04 14:00:00+02	40.9763999999999982	0	95
1991-09-04 15:00:00+02	45.5878000000000014	0	95
1991-09-04 16:00:00+02	42.3547999999999973	0	95
1991-09-04 17:00:00+02	34.6356999999999999	0	95
1991-09-04 18:00:00+02	30.4754000000000005	0	95
1991-09-04 19:00:00+02	30.5004999999999988	0	95
1991-09-04 20:00:00+02	34.0090999999999966	0	95
1991-09-04 21:00:00+02	32.6807999999999979	0	95
1991-09-04 22:00:00+02	34.6858000000000004	0	95
1991-09-04 23:00:00+02	35.9388999999999967	0	95
1991-09-05 00:00:00+02	31.1019000000000005	0	95
1991-09-05 01:00:00+02	28.2950000000000017	0	95
1991-09-05 02:00:00+02	25.7637	0	95
1991-09-05 03:00:00+02	24.4103999999999992	0	95
1991-09-05 04:00:00+02	22.8064	0	95
1991-09-05 05:00:00+02	23.5582999999999991	0	95
1991-09-05 06:00:00+02	23.9592999999999989	0	95
1991-09-05 07:00:00+02	25.5883000000000003	0	95
1991-09-05 08:00:00+02	23.4579999999999984	0	95
1991-09-05 09:00:00+02	22.4304999999999986	0	95
1991-09-05 10:00:00+02	22.5808999999999997	0	95
1991-09-05 11:00:00+02	24.5106000000000002	0	95
1991-09-05 12:00:00+02	23.9843000000000011	0	95
1991-09-05 13:00:00+02	24.5608000000000004	0	95
1991-09-05 14:00:00+02	28.194700000000001	0	95
1991-09-05 15:00:00+02	31.0268000000000015	0	95
1991-09-05 16:00:00+02	32.5054000000000016	0	95
1991-09-05 17:00:00+02	40.4249999999999972	0	95
1991-09-05 18:00:00+02	42.1041999999999987	0	95
1991-09-05 19:00:00+02	41.0013999999999967	0	95
1991-09-05 20:00:00+02	39.9739000000000004	0	95
1991-09-05 21:00:00+02	38.0191000000000017	0	95
1991-09-05 22:00:00+02	36.7158000000000015	0	95
1991-09-05 23:00:00+02	35.7884999999999991	0	95
1991-09-06 00:00:00+02	34.7109000000000023	0	95
1991-09-06 01:00:00+02	34.6606999999999985	0	95
1991-09-06 02:00:00+02	34.4100999999999999	0	95
1991-09-06 03:00:00+02	35.4125999999999976	0	95
1991-09-06 04:00:00+02	35.4878	0	95
1991-09-06 05:00:00+02	29.4227999999999987	0	95
1991-09-06 06:00:00+02	33.207099999999997	0	95
1991-09-06 07:00:00+02	35.5630000000000024	0	95
1991-09-06 08:00:00+02	22.6559999999999988	0	95
1991-09-06 09:00:00+02	27.6433999999999997	0	95
1991-09-06 10:00:00+02	41.8034000000000034	0	95
1991-09-06 11:00:00+02	51.5775999999999968	0	95
1991-09-06 12:00:00+02	55.4622000000000028	0	95
1991-09-06 13:00:00+02	57.6677000000000035	0	95
1991-09-06 14:00:00+02	59.8982000000000028	0	95
1991-09-06 15:00:00+02	63.6073999999999984	0	95
1991-09-06 16:00:00+02	63.0559999999999974	0	95
1991-09-06 17:00:00+02	60.4245000000000019	0	95
1991-09-06 18:00:00+02	59.196399999999997	0	95
1991-09-06 19:00:00+02	64.0584999999999951	0	95
1991-09-06 20:00:00+02	59.7728999999999999	0	95
1991-09-06 21:00:00+02	56.8656999999999968	0	95
1991-09-06 22:00:00+02	49.1465999999999994	0	95
1991-09-06 23:00:00+02	43.4324000000000012	0	95
1991-09-07 00:00:00+02	56.0636999999999972	0	95
1991-09-07 01:00:00+02	54.0337000000000032	0	95
1991-09-07 02:00:00+02	56.4146000000000001	0	95
1991-09-07 03:00:00+02	54.9108000000000018	0	95
1991-09-07 04:00:00+02	52.2291999999999987	0	95
1991-09-07 05:00:00+02	50.0488	0	95
1991-09-07 06:00:00+02	45.9136000000000024	0	95
1991-09-07 08:00:00+02	50.9009	0	95
1991-09-07 09:00:00+02	53.6828000000000003	0	95
1991-09-07 10:00:00+02	49.7730999999999995	0	95
1991-09-07 11:00:00+02	46.7657000000000025	0	95
1991-09-07 12:00:00+02	48.2192999999999969	0	95
1991-09-07 13:00:00+02	48.6955000000000027	0	95
1991-09-07 14:00:00+02	49.5977000000000032	0	95
1991-09-07 15:00:00+02	51.1514999999999986	0	95
1991-09-07 16:00:00+02	53.9834999999999994	0	95
1991-09-07 17:00:00+02	54.9859999999999971	0	95
1991-09-07 18:00:00+02	54.3845000000000027	0	95
1991-09-07 19:00:00+02	48.3194999999999979	0	95
1991-09-07 20:00:00+02	53.3318999999999974	0	95
1999-07-02 20:00:00+02	49.1214999999999975	0	96
1999-07-02 21:00:00+02	48.6203000000000003	0	96
1999-07-02 22:00:00+02	41.6028999999999982	0	96
1999-07-02 23:00:00+02	29.0718999999999994	0	96
1999-07-03 00:00:00+02	10.0248000000000008	0	96
1999-07-03 01:00:00+02	4.51116000000000028	0	96
1999-07-03 02:00:00+02	1.75434000000000001	0	96
1999-07-03 03:00:00+02	16.0396999999999998	0	96
1999-07-03 04:00:00+02	21.3027000000000015	0	96
1999-07-03 05:00:00+02	10.2753999999999994	0	96
1999-07-03 06:00:00+02	27.8187999999999995	0	96
1999-07-03 07:00:00+02	45.1116000000000028	0	96
1999-07-03 08:00:00+02	51.6276999999999973	0	96
1999-07-03 09:00:00+02	44.6103999999999985	0	96
1999-07-03 10:00:00+02	44.109099999999998	0	96
1999-07-03 11:00:00+02	48.8708999999999989	0	96
1999-07-03 12:00:00+02	50.1240000000000023	0	96
1999-07-03 13:00:00+02	50.8759000000000015	0	96
1999-07-03 14:00:00+02	57.8932000000000002	0	96
1999-07-03 15:00:00+02	62.1537999999999968	0	96
1999-07-03 16:00:00+02	58.6450999999999993	0	96
1999-07-03 17:00:00+02	59.1462999999999965	0	96
1999-07-03 18:00:00+02	58.3945000000000007	0	96
1999-07-03 19:00:00+02	51.3770999999999987	0	96
1999-07-03 20:00:00+02	45.1116000000000028	0	96
1999-07-03 21:00:00+02	35.8387000000000029	0	96
1999-07-03 22:00:00+02	30.3249999999999993	0	96
1999-07-03 23:00:00+02	24.0594999999999999	0	96
1999-07-04 00:00:00+02	21.8038999999999987	0	96
1999-07-04 02:00:00+02	9.02232000000000056	0	96
1999-07-04 03:00:00+02	8.27045999999999992	0	96
1999-07-04 04:00:00+02	6.51611999999999991	0	96
1999-07-04 05:00:00+02	5.01240000000000041	0	96
1999-07-04 06:00:00+02	5.26302000000000003	0	96
1999-07-04 07:00:00+02	4.51116000000000028	0	96
1999-07-04 08:00:00+02	4.00992000000000015	0	96
1999-07-04 09:00:00+02	8.52107999999999954	0	96
1999-07-04 10:00:00+02	18.5458999999999996	0	96
1999-07-04 11:00:00+02	25.0620000000000012	0	96
1999-07-04 12:00:00+02	27.3175999999999988	0	96
1999-07-04 13:00:00+02	29.8237999999999985	0	96
1999-07-04 14:00:00+02	35.8387000000000029	0	96
1999-07-04 15:00:00+02	41.8534999999999968	0	96
1999-07-04 16:00:00+02	46.8659000000000034	0	96
1999-07-04 17:00:00+02	44.8609999999999971	0	96
1999-07-04 18:00:00+02	39.597999999999999	0	96
1999-07-04 19:00:00+02	44.3596999999999966	0	96
1999-07-04 20:00:00+02	39.8485999999999976	0	96
1999-07-04 21:00:00+02	42.8560000000000016	0	96
1999-07-04 22:00:00+02	42.3547999999999973	0	96
1999-07-04 23:00:00+02	36.5904999999999987	0	96
1999-07-05 00:00:00+02	36.0893000000000015	0	96
1999-07-05 01:00:00+02	25.5631999999999984	0	96
1999-07-05 07:00:00+02	21.0520999999999994	0	96
1999-07-05 08:00:00+02	22.5558000000000014	0	96
1999-07-05 09:00:00+02	22.0546000000000006	0	96
1999-07-05 10:00:00+02	17.7940000000000005	0	96
1999-07-05 11:00:00+02	16.7914999999999992	0	96
1999-07-05 12:00:00+02	14.7866	0	96
1999-07-05 15:00:00+02	26.0644999999999989	0	96
1999-07-05 17:00:00+02	46.8659000000000034	0	96
1999-07-05 18:00:00+02	51.6276999999999973	0	96
1999-07-05 19:00:00+02	52.3796000000000035	0	96
1999-07-05 20:00:00+02	51.6276999999999973	0	96
1999-07-05 21:00:00+02	49.3721000000000032	0	96
1999-07-05 22:00:00+02	46.6152999999999977	0	96
1999-07-05 23:00:00+02	40.3498000000000019	0	96
1999-07-06 00:00:00+02	23.3077000000000005	0	96
1999-07-06 01:00:00+02	9.5235599999999998	0	96
1999-07-06 02:00:00+02	7.51860000000000017	0	96
1999-07-06 03:00:00+02	8.0198400000000003	0	96
1999-07-06 04:00:00+02	7.01736000000000004	0	96
1999-07-06 05:00:00+02	5.26302000000000003	0	96
1999-07-06 06:00:00+02	4.00992000000000015	0	96
1999-07-06 07:00:00+02	1.00248000000000004	0	96
1999-07-06 08:00:00+02	1.00248000000000004	0	96
1999-07-06 09:00:00+02	1.75434000000000001	0	96
1999-07-06 10:00:00+02	3.25805999999999996	0	96
1999-07-06 11:00:00+02	6.51611999999999991	0	96
1999-07-06 12:00:00+02	12.5310000000000006	0	96
1999-07-06 13:00:00+02	17.5433999999999983	0	96
1999-07-06 14:00:00+02	27.3175999999999988	0	96
1999-07-06 15:00:00+02	15.7890999999999995	0	96
1999-07-06 16:00:00+02	22.8064	0	96
1999-07-06 17:00:00+02	25.0620000000000012	0	96
1999-07-06 18:00:00+02	28.5706999999999987	0	96
1999-07-06 19:00:00+02	34.5855999999999995	0	96
1999-07-06 20:00:00+02	35.588000000000001	0	96
1999-07-06 21:00:00+02	35.3374000000000024	0	96
1999-07-06 22:00:00+02	34.5855999999999995	0	96
1999-07-06 23:00:00+02	22.0546000000000006	0	96
1999-07-07 00:00:00+02	7.26797999999999966	0	96
1999-07-07 02:00:00+02	7.26797999999999966	0	96
1999-07-07 03:00:00+02	7.76921999999999979	0	96
1999-07-07 04:00:00+02	6.51611999999999991	0	96
1999-07-07 05:00:00+02	4.51116000000000028	0	96
1999-07-07 06:00:00+02	3.25805999999999996	0	96
1999-07-07 07:00:00+02	2.25558000000000014	0	96
1999-07-07 08:00:00+02	3.50868000000000002	0	96
1999-07-07 09:00:00+02	6.01487999999999978	0	96
\.


--
-- Data for Name: organisations; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.organisations (id, name, longname, kind, city, postcode, street_address, country, homepage) FROM stdin;
0			7					
35	UBA	Umweltbundesamt	1				Germany	
36	LANUV	Landesamt für Natur, Umwelt und Verbraucherschutz Nordrhein-Westfalen	1				Germany	
\.


--
-- Data for Name: persons; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.persons (id, name, email, phone, isprivate) FROM stdin;
0				t
\.


--
-- Data for Name: stationmeta_annotations; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_annotations (id, kind, text, date_added, approved, contributor_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_aux_doc; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_aux_doc (id, resource_description, date_added, resource, station_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_aux_image; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_aux_image (id, resource_description, date_added, resource, image_height, image_width, station_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_aux_url; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_aux_url (id, resource_description, date_added, resource, station_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_core; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_core (id, codes, name, coordinates, country, state, coordinate_validation_status, coordinate_validation_date, type_of_environment, type_of_area, timezone, additional_metadata, coordinate_validator_id) FROM stdin;
57	{DEUB001}	Westerland	01010000A0E6100000AF997CB3CD9D2040FCE3BD6A65764B400000000000002840	Germany		0	2020-07-06 15:30:31.959077+02	1	3	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "611", "station_google_alt": "8", "station_reported_alt": "12", "station_landcover_description": "Water:86.1%,Grasslands:4.8%,Croplands:4.6%,Permanentwetlands:1.8%,Cropland/Naturalvegetationmosaic:1.1%", "station_max_population_density_5km": "953"}	1
58	{DENW200}	Bielefeld Detmolder Straße	01010000A0E61000002B323A20091B21404E098849B8004A400000000000206140	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:32.389685+02	2	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "140", "station_reported_alt": "137", "station_landcover_description": "Cropland/Naturalvegetationmosaic:34.7%,Croplands:32.0%,Urbanandbuilt-up:17.2%,Mixedforest:14.8%", "station_max_population_density_5km": "16191"}	1
59	{DEUB028}	Zingst	01010000A0E6100000C1E270E657732940799274CDE4374B40000000000000F03F	Germany		1	2020-07-06 15:30:32.836531+02	1	3	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "611", "station_google_alt": "1", "station_reported_alt": "1", "station_landcover_description": "Water:55.7%,Croplands:20.5%,Mixedforest:8.7%,Cropland/Naturalvegetationmosaic:8.3%,Permanentwetlands:2.3%,Grasslands:2.2%,EvergreenNeedleleafforest:1.2%", "station_max_population_density_5km": "386"}	1
60	{DENW094}	Aachen-Burtscheid	01010000A0E61000006C5ED5592D601840871403249A6049400000000000A06940	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:33.262202+02	1	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "153", "station_google_alt": "200", "station_reported_alt": "205", "station_landcover_description": "Mixedforest:32.8%,Cropland/Naturalvegetationmosaic:29.2%,Urbanandbuilt-up:16.5%,Croplands:15.9%,Grasslands:3.5%,EvergreenNeedleleafforest:1.9%", "station_max_population_density_5km": "20125"}	1
61	{DENW067}	Bielefeld-Ost	01010000A0E6100000E8F86871C6182140F9A3A833F7024A400000000000805940	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:33.666526+02	1	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "106", "station_reported_alt": "102", "station_landcover_description": "Croplands:38.6%,Cropland/Naturalvegetationmosaic:32.5%,Urbanandbuilt-up:16.4%,Mixedforest:11.4%", "station_max_population_density_5km": "16191"}	1
62	{DENW081}	Borken-Gemen	01010000A0E61000000C5872158B7F1B407593180456EE49400000000000804640	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:34.087847+02	1	3	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "45", "station_reported_alt": "45", "station_landcover_description": "Cropland/Naturalvegetationmosaic:55.4%,Mixedforest:18.5%,Croplands:15.2%,Urbanandbuilt-up:9.8%", "station_max_population_density_5km": "3569"}	1
63	{DENW021}	Bottrop-Welheim	01010000A0E610000096CD1C925AE81B40F9F36DC152C349400000000000004440	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:34.500984+02	3	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "31", "station_reported_alt": "40", "station_landcover_description": "Urbanandbuilt-up:47.2%,Mixedforest:23.7%,Cropland/Naturalvegetationmosaic:12.5%,Croplands:8.6%,EvergreenNeedleleafforest:6.1%", "station_max_population_density_5km": "34286"}	1
64	{DENW008}	Dortmund-Eving	01010000A0E61000002B85402E71D41D406CEEE87FB9C449400000000000C05240	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:34.924539+02	1	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "68", "station_reported_alt": "75", "station_landcover_description": "Urbanandbuilt-up:41.1%,Mixedforest:23.7%,Croplands:20.8%,Cropland/Naturalvegetationmosaic:11.7%,EvergreenNeedleleafforest:1.9%", "station_max_population_density_5km": "27082"}	1
65	{DENW034}	Duisburg-Walsum	01010000A0E6100000410B09185DFE1A403831242713C349400000000000003C40	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:35.373971+02	3	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "18", "station_reported_alt": "28", "station_landcover_description": "Urbanandbuilt-up:34.7%,Croplands:20.5%,Cropland/Naturalvegetationmosaic:20.1%,Mixedforest:17.1%,EvergreenNeedleleafforest:6.0%", "station_max_population_density_5km": "26864"}	1
66	{DENW071}	Düsseldorf-Lörick	01010000A0E6100000E19524CFF5ED1A40D8666325E69F49400000000000004040	Germany	Nordrhein-Westfalen	0	2020-07-06 15:30:35.809923+02	1	1	Europe/Berlin	{"station_alt_flag": "0", "google_resolution": "19", "station_google_alt": "35", "station_reported_alt": "32", "station_landcover_description": "Urbanandbuilt-up:48.2%,Croplands:27.5%,Mixedforest:11.9%,Cropland/Naturalvegetationmosaic:7.2%,EvergreenNeedleleafforest:3.6%", "station_max_population_density_5km": "34528"}	1
2	{CO002}	U. S.Buenaventura	01010000A0E61000004260E5D0221B314054E3A59BC42042400000000000F89740	Colombia	ANTIOQUIA	0	2020-07-06 15:30:35.809923+02	1	1	America/Bogota	{}	1
\.


--
-- Data for Name: stationmeta_core_stationmeta_annotations; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_core_stationmeta_annotations (station_id, annotation_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_core_stationmeta_roles; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_core_stationmeta_roles (station_id, role_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_global; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_global (id, population_density_year2010, max_population_density_25km_year2010, climatic_zone, nightlight_1km_year2013, nightlight_5km_year2013, max_nightlight_25km_year2013, wheat_production_year2000, rice_production_year2000, edgar_htap_v2_nox_emissions_year2010, omi_no2_column_years2011to2015, htap_region_tier1, etopo_alt, etopo_min_alt_5km, etopo_relative_alt, dominant_landcover_year2012, toar1_category, station_id) FROM stdin;
15	953	1017	3	46	20.7300000000000004	56	0	0	0.672115000000000018	2.27000000000000002	4	3	0	3	12	1	57
16	16191	16191	3	53	51.0300000000000011	62	2.33199999999999985	0	14.1422000000000008	5.23000000000000043	4	180	92	88	5	0	58
17	349	6619	3	9	6.37999999999999989	60	1.37999999999999989	0	0.0936120000000000008	2.31000000000000005	4	1	0	1	11	1	59
18	14514	26839	3	48	46.8699999999999974	62	0.958999999999999964	0	4.94151999999999969	7.05999999999999961	4	225	159	66	5	0	60
19	16176	16191	3	60	54.2999999999999972	62	2.33199999999999985	0	14.1422000000000008	5.23000000000000043	4	114	85	29	13	0	61
20	3566	12635	3	48	24.1400000000000006	58	2.95400000000000018	0	2.20976999999999979	7.99000000000000021	4	49	41	8	14	0	62
21	20282	39682	3	61	60.9500000000000028	63	0.649000000000000021	0	19.9934000000000012	10.4800000000000004	4	38	32	6	13	3	63
22	27057	39682	3	62	59.7700000000000031	63	2.18299999999999983	0	17.1243000000000016	9.11999999999999922	4	75	69	6	13	3	64
23	26631	36502	1	61	58.3999999999999986	63	3.59299999999999997	0	20.3846999999999987	11.1500000000000004	4	21	19	2	13	3	65
24	29515	34559	1	63	61.25	63	1.38700000000000001	0	43.8791000000000011	11.4700000000000006	4	34	29	5	13	3	66
\.


--
-- Data for Name: stationmeta_global_services; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_global_services (id, variable_name, result_type, result_nvalues, service_valid_year, service_url, station_id) FROM stdin;
\.


--
-- Data for Name: stationmeta_roles; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.stationmeta_roles (id, role, status, contact_id) FROM stdin;
\.


--
-- Data for Name: timeseries; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.timeseries (id, label, "order", access_rights, sampling_frequency, aggregation, data_start_date, data_end_date, sampling_height, additional_metadata, date_added, date_modified, station_id, variable_id, source, measurement_method, programme_id) FROM stdin;
94		1	0	0	1	1990-01-01 00:00:00+01	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.490069+02	57	5	1	1	0
95		1	0	0	1	1991-09-03 14:00:00+02	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.500565+02	59	5	1	1	0
96		1	0	0	1	1999-07-02 18:00:00+02	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.277197+02	60	5	1	1	0
97		1	0	0	1	1990-01-01 00:00:00+01	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.25835+02	61	5	1	1	0
98		1	0	0	1	1998-09-12 00:00:00+02	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.274872+02	62	5	1	1	0
99		1	0	0	1	1990-09-13 12:00:00+02	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.237371+02	63	5	1	1	0
100		1	0	0	1	1990-04-01 00:00:00+02	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.232375+02	64	5	1	1	0
101		1	0	0	1	1990-01-01 00:00:00+01	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.239781+02	65	5	1	1	0
102		1	0	0	1	1990-01-18 14:00:00+01	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.263259+02	66	5	1	1	0
2	'IDEAM'	1	0	0	1	1990-01-18 14:00:00+01	2020-07-06 15:00:00+02	2	{"parameter_status": "0", "parameter_attribute": "", "parameter_sampling_type": "continuous", "parameter_original_units": "ug m-3", "parameter_instrument_model": "", "parameter_instrument_manufacturer": ""}	2015-03-04 15:54:28.457564+01	2020-07-06 18:04:58.263259+02	2	5	1	1	0
\.


--
-- Data for Name: timeseries_annotations; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.timeseries_annotations (id, kind, text, date_added, approved, contributor_id) FROM stdin;
\.


--
-- Data for Name: timeseries_programmes; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.timeseries_programmes (id, name, longname, homepage, description) FROM stdin;
0	None			
1	EMEP	Co-operative programme for monitoring and evaluation of the long-range transmission of air pollutants in Europe	https://www.emep.int/	EMEP is a scientifically based and policy driven programme under the Convention on Long-range Transboundary Air Pollution (CLRTAP) for international co-operation to solve transboundary air pollution problems.
2	GAW	Global Atmosphere Watch Programme of WMO	https://community.wmo.int/activity-areas/gaw	GAW focuses on building a single coordinated global understanding of atmospheric composition, its change, and helps to improve the understanding of interactions between the atmosphere, the oceans and the biosphere.
3	OpenAQ	OpenAQ	https://openaq.org	OpenAQ is a non-profit organization empowering communities around the globe to clean their air by harmonizing, sharing, and using open air quality data.
\.


--
-- Data for Name: timeseries_roles; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.timeseries_roles (id, role, status, contact_id) FROM stdin;
49	3	0	39
50	3	0	40
\.


--
-- Data for Name: timeseries_timeseries_annotations; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.timeseries_timeseries_annotations (timeseries_id, annotation_id) FROM stdin;
\.


--
-- Data for Name: timeseries_timeseries_roles; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.timeseries_timeseries_roles (timeseries_id, role_id) FROM stdin;
94	49
95	49
96	50
97	50
98	50
99	50
100	50
101	50
102	50
\.


--
-- Data for Name: us_gaz; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.us_gaz (id, seq, word, stdword, token, is_custom) FROM stdin;
\.


--
-- Data for Name: us_lex; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.us_lex (id, seq, word, stdword, token, is_custom) FROM stdin;
\.


--
-- Data for Name: us_rules; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.us_rules (id, rule, is_custom) FROM stdin;
\.


--
-- Data for Name: variables; Type: TABLE DATA; Schema: public; Owner: toarcurator
--

COPY public.variables (id, name, longname, displayname, cf_standardname, units, chemical_formula) FROM stdin;
1	benzene	benzene	Benzene	mole_fraction_of_benzene_in_air	nmol mol-1	C6H6
2	co	carbon monoxide	CO	mole_fraction_of_carbon_monoxide_in_air	nmol mol-1	CO
3	no	nitrogen monoxide	NO	mole_fraction_of_nitrogen_monoxide_in_air	nmol mol-1	NO
4	pm1	particles up to 1 µm diameter	PM 1	mass_concentration_of_pm1_ambient_aerosol_in_air	µg m-3	
5	o3	ozone	Ozone	mole_fraction_of_ozone_in_air	nmol mol-1	O3
6	no2	nitrogen dioxide	NO2	mole_fraction_of_nitrogen_dioxide_in_air	nmol mol-1	NO2
7	toluene	toluene	Toluene	mole_fraction_of_toluene_in_air	nmol mol-1	C7H8
8	so2	Sulphur dioxide	SO2	mole_fraction_of_sulfur_dioxide_in_air	nmol mol-1	SO2
9	ethane	Ethane	Ethane	mole_fraction_of_ethane_in_air	nmol mol-1	C2H6
10	propane	Propane	Propane	mole_fraction_of_propane_in_air	nmol mol-1	C3H8
11	ox	Ox	Ox		nmol mol-1	
12	aswdir	direct downward sw radiation	downward sw radiation	surface_downwelling_shortwave_flux_in_air	W/m**2	
13	pm10	particles up to 10 µm diameter	PM 10	mass_concentration_of_pm10_ambient_aerosol_in_air	µg m-3	
14	rn	radon	Radon		mBq m-3	Rn
15	mpxylene	m,p-xylene	m,p-Xylene		nmol mol-1	C8H10
16	oxylene	o-xylene	o-Xylene		nmol mol-1	C8H10
17	ch4	Methane	CH4	mole_fraction_of_methane_in_air	nmol mol-1	CH4
18	wdir	wind direction	Wind direction	wind_from_direction	degrees	
19	pm2p5	particles up to 2.5 µm diameter	PM 2.5	mass_concentration_of_pm2p5_ambient_aerosol_in_air	µg m-3	
20	nox	reactive nitrogen oxides (NO+NO2)	NOx	mole_fraction_of_nox_expressed_as_nitrogen_in_air	nmol mol-1	
21	temp	atmospheric temperature	Temperature	air_temperature	degC	
22	wspeed	wind speed	Wind speed	wind_speed	m s-1	
23	press	atmospheric pressure	Pressure	air_pressure	hPa	
24	cloudcover	total cloud cover	total cloud cover	cloud_area_fraction	%	
25	pblheight	height of PBL	PBL height	atmosphere_boundary_layer_thickness	m	
26	relhum	relative humidity	relative humidity	relative_humidity	%	
27	totprecip	total precipitation	total precipitation	precipitation_amount	kg m-2	
28	u	u-component (zonal) of wind	U	x_wind	m s-1	
29	v	v-component (meridional) of wind	V	y_wind	m s-1	
30	albedo	albedo	albedo	surface_albedo	%	
31	aswdifu	diffuse upward sw radiation	upward sw radiation		W/m**2	
32	humidity	atmospheric humidity	Humidity	specific_humidity	g kg-1	
33	irradiance	global surface irradiance	solar irradiance		W m-2	
34	benzene95	benzene	Benzene	mole_fraction_of_benzene_in_air	nmol mol-1	C6H6
35	benzene97	benzene	Benzene	mole_fraction_of_benzene_in_air	nmol mol-1	C6H6
36	benzene98	benzene	Benzene	mole_fraction_of_benzene_in_air	nmol mol-1	C6H6
37	benzene99	benzene	Benzene	mole_fraction_of_benzene_in_air	nmol mol-1	C6H6
\.


--
-- Data for Name: geocode_settings; Type: TABLE DATA; Schema: tiger; Owner: toarcurator
--

COPY tiger.geocode_settings (name, setting, unit, category, short_desc) FROM stdin;
\.


--
-- Data for Name: pagc_gaz; Type: TABLE DATA; Schema: tiger; Owner: toarcurator
--

COPY tiger.pagc_gaz (id, seq, word, stdword, token, is_custom) FROM stdin;
\.


--
-- Data for Name: pagc_lex; Type: TABLE DATA; Schema: tiger; Owner: toarcurator
--

COPY tiger.pagc_lex (id, seq, word, stdword, token, is_custom) FROM stdin;
\.


--
-- Data for Name: pagc_rules; Type: TABLE DATA; Schema: tiger; Owner: toarcurator
--

COPY tiger.pagc_rules (id, rule, is_custom) FROM stdin;
\.


--
-- Data for Name: topology; Type: TABLE DATA; Schema: topology; Owner: toarcurator
--

COPY topology.topology (id, name, srid, "precision", hasz) FROM stdin;
\.


--
-- Data for Name: layer; Type: TABLE DATA; Schema: topology; Owner: toarcurator
--

COPY topology.layer (topology_id, layer_id, schema_name, table_name, feature_column, feature_type, level, child_id) FROM stdin;
\.


--
-- Name: auth_user_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.auth_user_id_seq', 2, true);


--
-- Name: contacts_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.contacts_id_seq', 40, true);


--
-- Name: organisations_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.organisations_id_seq', 36, true);


--
-- Name: persons_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.persons_id_seq', 7, true);


--
-- Name: stationmeta_annotations_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_annotations_id_seq', 1, false);


--
-- Name: stationmeta_aux_doc_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_aux_doc_id_seq', 1, false);


--
-- Name: stationmeta_aux_image_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_aux_image_id_seq', 1, true);


--
-- Name: stationmeta_aux_url_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_aux_url_id_seq', 1, false);


--
-- Name: stationmeta_core_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_core_id_seq', 66, true);


--
-- Name: stationmeta_global_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_global_id_seq', 24, true);


--
-- Name: stationmeta_global_services_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_global_services_id_seq', 6, true);


--
-- Name: stationmeta_roles_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.stationmeta_roles_id_seq', 9, true);


--
-- Name: timeseries_annotations_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.timeseries_annotations_id_seq', 1, false);


--
-- Name: timeseries_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.timeseries_id_seq', 102, true);


--
-- Name: timeseries_programmes_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.timeseries_programmes_id_seq', 1, false);


--
-- Name: timeseries_roles_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.timeseries_roles_id_seq', 50, true);


--
-- Name: variables_id_seq; Type: SEQUENCE SET; Schema: public; Owner: toarcurator
--

SELECT pg_catalog.setval('public.variables_id_seq', 37, true);


--
-- Name: auth_user auth_user_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.auth_user
    ADD CONSTRAINT auth_user_pkey PRIMARY KEY (id);


--
-- Name: auth_user auth_user_username_key; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.auth_user
    ADD CONSTRAINT auth_user_username_key UNIQUE (username);


--
-- Name: contacts contacts_person_id_organisation_id; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.contacts
    ADD CONSTRAINT contacts_person_id_organisation_id UNIQUE (person_id, organisation_id);


--
-- Name: contacts contacts_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.contacts
    ADD CONSTRAINT contacts_pkey PRIMARY KEY (id);


--
-- Name: data data_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.data
    ADD CONSTRAINT data_pkey PRIMARY KEY (timeseries_id, datetime);


--
-- Name: data data_timeseries_id_datetime_7daa6d17_uniq; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.data
    ADD CONSTRAINT data_timeseries_id_datetime_7daa6d17_uniq UNIQUE (timeseries_id, datetime);


--
-- Name: organisations organisations_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.organisations
    ADD CONSTRAINT organisations_pkey PRIMARY KEY (id);


--
-- Name: persons persons_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.persons
    ADD CONSTRAINT persons_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_annotations stationmeta_annotations_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_annotations
    ADD CONSTRAINT stationmeta_annotations_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_aux_doc stationmeta_aux_doc_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_doc
    ADD CONSTRAINT stationmeta_aux_doc_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_aux_image stationmeta_aux_image_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_image
    ADD CONSTRAINT stationmeta_aux_image_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_aux_url stationmeta_aux_url_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_url
    ADD CONSTRAINT stationmeta_aux_url_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_core stationmeta_core_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core
    ADD CONSTRAINT stationmeta_core_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_core_stationmeta_annotations stationmeta_core_stationmeta_annotations_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core_stationmeta_annotations
    ADD CONSTRAINT stationmeta_core_stationmeta_annotations_pkey PRIMARY KEY (station_id, annotation_id);


--
-- Name: stationmeta_core_stationmeta_roles stationmeta_core_stationmeta_roles_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core_stationmeta_roles
    ADD CONSTRAINT stationmeta_core_stationmeta_roles_pkey PRIMARY KEY (station_id, role_id);


--
-- Name: stationmeta_global stationmeta_global_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_global_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_global_services stationmeta_global_services_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global_services
    ADD CONSTRAINT stationmeta_global_services_pkey PRIMARY KEY (id);


--
-- Name: stationmeta_global_services stationmeta_global_services_service_url_key; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global_services
    ADD CONSTRAINT stationmeta_global_services_service_url_key UNIQUE (service_url);


--
-- Name: stationmeta_global stationmeta_global_station_id_key; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_global_station_id_key UNIQUE (station_id);


--
-- Name: stationmeta_roles stationmeta_roles_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_roles
    ADD CONSTRAINT stationmeta_roles_pkey PRIMARY KEY (id);


--
-- Name: timeseries_annotations timeseries_annotations_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_annotations
    ADD CONSTRAINT timeseries_annotations_pkey PRIMARY KEY (id);


--
-- Name: timeseries timeseries_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_pkey PRIMARY KEY (id);


--
-- Name: timeseries_programmes timeseries_programmes_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_programmes
    ADD CONSTRAINT timeseries_programmes_pkey PRIMARY KEY (id);


--
-- Name: timeseries_roles timeseries_roles_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_roles
    ADD CONSTRAINT timeseries_roles_pkey PRIMARY KEY (id);


--
-- Name: timeseries_roles timeseries_roles_role_status_contact_id_uniq; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_roles
    ADD CONSTRAINT timeseries_roles_role_status_contact_id_uniq UNIQUE (role, status, contact_id);


--
-- Name: timeseries timeseries_station_id_variable_id_label_055cfe3a_uniq; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_station_id_variable_id_label_055cfe3a_uniq UNIQUE (station_id, variable_id, label);


--
-- Name: timeseries_timeseries_annotations timeseries_timeseries_annotations_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_timeseries_annotations
    ADD CONSTRAINT timeseries_timeseries_annotations_pkey PRIMARY KEY (timeseries_id, annotation_id);


--
-- Name: timeseries_timeseries_roles timeseries_timeseries_roles_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_timeseries_roles
    ADD CONSTRAINT timeseries_timeseries_roles_pkey PRIMARY KEY (timeseries_id, role_id);


--
-- Name: variables variables_name_key; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.variables
    ADD CONSTRAINT variables_name_key UNIQUE (name);


--
-- Name: variables variables_pkey; Type: CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.variables
    ADD CONSTRAINT variables_pkey PRIMARY KEY (id);


--
-- Name: auth_user_username_6821ab7c_like; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX auth_user_username_6821ab7c_like ON public.auth_user USING btree (username varchar_pattern_ops);


--
-- Name: data_datetime_4b248149; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX data_datetime_4b248149 ON public.data USING btree (datetime);


--
-- Name: data_timeseries_id_a38c5a1a; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX data_timeseries_id_a38c5a1a ON public.data USING btree (timeseries_id);


--
-- Name: data_value_idx; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX data_value_idx ON public.data USING btree (value);


--
-- Name: stationmeta_annotations_contributor_id_a5009820; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_annotations_contributor_id_a5009820 ON public.stationmeta_annotations USING btree (contributor_id);


--
-- Name: stationmeta_aux_doc_station_id_17bdb5f2; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_aux_doc_station_id_17bdb5f2 ON public.stationmeta_aux_doc USING btree (station_id);


--
-- Name: stationmeta_aux_image_station_id_fbfbdb29; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_aux_image_station_id_fbfbdb29 ON public.stationmeta_aux_image USING btree (station_id);


--
-- Name: stationmeta_aux_url_station_id_727571bd; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_aux_url_station_id_727571bd ON public.stationmeta_aux_url USING btree (station_id);


--
-- Name: stationmeta_core_coordinate_validator_id_38c0ef8d; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_core_coordinate_validator_id_38c0ef8d ON public.stationmeta_core USING btree (coordinate_validator_id);


--
-- Name: stationmeta_core_coordinates_id; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_core_coordinates_id ON public.stationmeta_core USING gist (coordinates postgis.gist_geometry_ops_nd);


--
-- Name: stationmeta_core_country_fa755dde; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_core_country_fa755dde ON public.stationmeta_core USING btree (country);


--
-- Name: stationmeta_core_country_fa755dde_like; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_core_country_fa755dde_like ON public.stationmeta_core USING btree (country varchar_pattern_ops);


--
-- Name: stationmeta_core_state_85025a96; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_core_state_85025a96 ON public.stationmeta_core USING btree (state);


--
-- Name: stationmeta_core_state_85025a96_like; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_core_state_85025a96_like ON public.stationmeta_core USING btree (state varchar_pattern_ops);


--
-- Name: stationmeta_global_services_service_url_c8ee80c5_like; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_global_services_service_url_c8ee80c5_like ON public.stationmeta_global_services USING btree (service_url varchar_pattern_ops);


--
-- Name: stationmeta_roles_contact_id; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX stationmeta_roles_contact_id ON public.stationmeta_roles USING btree (contact_id);


--
-- Name: timeseries_annotations_contributor_id_7a1758f6; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX timeseries_annotations_contributor_id_7a1758f6 ON public.timeseries_annotations USING btree (contributor_id);


--
-- Name: timeseries_roles_contact_id; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX timeseries_roles_contact_id ON public.timeseries_roles USING btree (contact_id);


--
-- Name: timeseries_station_id_0f4fed9c; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX timeseries_station_id_0f4fed9c ON public.timeseries USING btree (station_id);


--
-- Name: timeseries_variable_id_dd9603f5; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX timeseries_variable_id_dd9603f5 ON public.timeseries USING btree (variable_id);


--
-- Name: variables_name_9bc98a13_like; Type: INDEX; Schema: public; Owner: toarcurator
--

CREATE INDEX variables_name_9bc98a13_like ON public.variables USING btree (name varchar_pattern_ops);


--
-- Name: contacts contacts_organisation_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.contacts
    ADD CONSTRAINT contacts_organisation_id_fkey FOREIGN KEY (organisation_id) REFERENCES public.organisations(id);


--
-- Name: contacts contacts_person_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.contacts
    ADD CONSTRAINT contacts_person_id_fkey FOREIGN KEY (person_id) REFERENCES public.persons(id);


--
-- Name: data data_flags_fk_df_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.data
    ADD CONSTRAINT data_flags_fk_df_vocabulary_enum_val FOREIGN KEY (flags) REFERENCES public.df_vocabulary(enum_val);


--
-- Name: data data_timeseries_id_a38c5a1a_fk_timeseries_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.data
    ADD CONSTRAINT data_timeseries_id_a38c5a1a_fk_timeseries_id FOREIGN KEY (timeseries_id) REFERENCES public.timeseries(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: organisations organisations_kind_fk_ok_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.organisations
    ADD CONSTRAINT organisations_kind_fk_ok_vocabulary_enum_val FOREIGN KEY (kind) REFERENCES public.ok_vocabulary(enum_val);


--
-- Name: stationmeta_annotations stationmeta_annotations_contributor_id_a5009820_fk_auth_user_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_annotations
    ADD CONSTRAINT stationmeta_annotations_contributor_id_a5009820_fk_auth_user_id FOREIGN KEY (contributor_id) REFERENCES public.auth_user(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_aux_doc stationmeta_aux_doc_station_id_17bdb5f2_fk_stationmeta_core_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_doc
    ADD CONSTRAINT stationmeta_aux_doc_station_id_17bdb5f2_fk_stationmeta_core_id FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_aux_image stationmeta_aux_imag_station_id_fbfbdb29_fk_stationme; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_image
    ADD CONSTRAINT stationmeta_aux_imag_station_id_fbfbdb29_fk_stationme FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_aux_url stationmeta_aux_url_station_id_727571bd_fk_stationmeta_core_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_aux_url
    ADD CONSTRAINT stationmeta_aux_url_station_id_727571bd_fk_stationmeta_core_id FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_core stationmeta_core_coord_valid_status_fk_cv_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core
    ADD CONSTRAINT stationmeta_core_coord_valid_status_fk_cv_vocabulary_enum_val FOREIGN KEY (coordinate_validation_status) REFERENCES public.cv_vocabulary(enum_val);


--
-- Name: stationmeta_core stationmeta_core_coordinate_validator_38c0ef8d_fk_auth_user; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core
    ADD CONSTRAINT stationmeta_core_coordinate_validator_38c0ef8d_fk_auth_user FOREIGN KEY (coordinate_validator_id) REFERENCES public.auth_user(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_core_stationmeta_annotations stationmeta_core_stationmeta_annotations_annotation_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core_stationmeta_annotations
    ADD CONSTRAINT stationmeta_core_stationmeta_annotations_annotation_id_fkey FOREIGN KEY (annotation_id) REFERENCES public.stationmeta_annotations(id);


--
-- Name: stationmeta_core_stationmeta_annotations stationmeta_core_stationmeta_annotations_station_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core_stationmeta_annotations
    ADD CONSTRAINT stationmeta_core_stationmeta_annotations_station_id_fkey FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id);


--
-- Name: stationmeta_core_stationmeta_roles stationmeta_core_stationmeta_roles_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core_stationmeta_roles
    ADD CONSTRAINT stationmeta_core_stationmeta_roles_role_id_fkey FOREIGN KEY (role_id) REFERENCES public.stationmeta_roles(id);


--
-- Name: stationmeta_core_stationmeta_roles stationmeta_core_stationmeta_roles_station_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core_stationmeta_roles
    ADD CONSTRAINT stationmeta_core_stationmeta_roles_station_id_fkey FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id);


--
-- Name: stationmeta_core stationmeta_core_type_of_area_fk_ta_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core
    ADD CONSTRAINT stationmeta_core_type_of_area_fk_ta_vocabulary_enum_val FOREIGN KEY (type_of_area) REFERENCES public.ta_vocabulary(enum_val);


--
-- Name: stationmeta_core stationmeta_core_type_of_environment_fk_st_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_core
    ADD CONSTRAINT stationmeta_core_type_of_environment_fk_st_vocabulary_enum_val FOREIGN KEY (type_of_environment) REFERENCES public.st_vocabulary(enum_val);


--
-- Name: stationmeta_global stationmeta_glob_dominant_landcover_year2012_fk_dl_voc_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_glob_dominant_landcover_year2012_fk_dl_voc_enum_val FOREIGN KEY (dominant_landcover_year2012) REFERENCES public.dl_vocabulary(enum_val);


--
-- Name: stationmeta_global stationmeta_global_climatic_zone_fk_cz_at_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_global_climatic_zone_fk_cz_at_vocabulary_enum_val FOREIGN KEY (climatic_zone) REFERENCES public.cz_vocabulary(enum_val);


--
-- Name: stationmeta_global stationmeta_global_htap_region_tier1_fk_tr_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_global_htap_region_tier1_fk_tr_vocabulary_enum_val FOREIGN KEY (htap_region_tier1) REFERENCES public.tr_vocabulary(enum_val);


--
-- Name: stationmeta_global_services stationmeta_global_services_result_type_fk_rt_voc_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global_services
    ADD CONSTRAINT stationmeta_global_services_result_type_fk_rt_voc_enum_val FOREIGN KEY (result_type) REFERENCES public.rt_vocabulary(enum_val);


--
-- Name: stationmeta_global_services stationmeta_global_services_station_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global_services
    ADD CONSTRAINT stationmeta_global_services_station_id_fkey FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id);


--
-- Name: stationmeta_global stationmeta_global_station_id_29ff53dd_fk_stationmeta_core_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_global_station_id_29ff53dd_fk_stationmeta_core_id FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_global stationmeta_global_toar1_category_fk_tc_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_global
    ADD CONSTRAINT stationmeta_global_toar1_category_fk_tc_vocabulary_enum_val FOREIGN KEY (toar1_category) REFERENCES public.tc_vocabulary(enum_val);


--
-- Name: stationmeta_roles stationmeta_roles_contact_id_fk_contacts_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_roles
    ADD CONSTRAINT stationmeta_roles_contact_id_fk_contacts_id FOREIGN KEY (contact_id) REFERENCES public.contacts(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: stationmeta_roles stationmeta_roles_role_fk_rc_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_roles
    ADD CONSTRAINT stationmeta_roles_role_fk_rc_vocabulary_enum_val FOREIGN KEY (role) REFERENCES public.rc_vocabulary(enum_val);


--
-- Name: stationmeta_roles stationmeta_roles_status_fk_rs_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.stationmeta_roles
    ADD CONSTRAINT stationmeta_roles_status_fk_rs_vocabulary_enum_val FOREIGN KEY (status) REFERENCES public.rs_vocabulary(enum_val);


--
-- Name: timeseries timeseries_access_rights_fk_da_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_access_rights_fk_da_vocabulary_enum_val FOREIGN KEY (access_rights) REFERENCES public.da_vocabulary(enum_val);


--
-- Name: timeseries timeseries_aggregation_fk_at_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_aggregation_fk_at_vocabulary_enum_val FOREIGN KEY (aggregation) REFERENCES public.at_vocabulary(enum_val);


--
-- Name: timeseries_annotations timeseries_annotations_contributor_id_7a1758f6_fk_auth_user_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_annotations
    ADD CONSTRAINT timeseries_annotations_contributor_id_7a1758f6_fk_auth_user_id FOREIGN KEY (contributor_id) REFERENCES public.auth_user(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: timeseries timeseries_measurement_method_fk_mm_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_measurement_method_fk_mm_vocabulary_enum_val FOREIGN KEY (measurement_method) REFERENCES public.mm_vocabulary(enum_val);


--
-- Name: timeseries timeseries_programme_id_fk_timeseries_programmes_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_programme_id_fk_timeseries_programmes_id FOREIGN KEY (programme_id) REFERENCES public.timeseries_programmes(id);


--
-- Name: timeseries_roles timeseries_roles_contact_id_fk_contacts_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_roles
    ADD CONSTRAINT timeseries_roles_contact_id_fk_contacts_id FOREIGN KEY (contact_id) REFERENCES public.contacts(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: timeseries_roles timeseries_roles_role_fk_rc_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_roles
    ADD CONSTRAINT timeseries_roles_role_fk_rc_vocabulary_enum_val FOREIGN KEY (role) REFERENCES public.rc_vocabulary(enum_val);


--
-- Name: timeseries_roles timeseries_roles_status_fk_rs_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_roles
    ADD CONSTRAINT timeseries_roles_status_fk_rs_vocabulary_enum_val FOREIGN KEY (status) REFERENCES public.rs_vocabulary(enum_val);


--
-- Name: timeseries timeseries_sampling_frequency_fk_sf_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_sampling_frequency_fk_sf_vocabulary_enum_val FOREIGN KEY (sampling_frequency) REFERENCES public.sf_vocabulary(enum_val);


--
-- Name: timeseries timeseries_source_fk_ds_vocabulary_enum_val; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_source_fk_ds_vocabulary_enum_val FOREIGN KEY (source) REFERENCES public.ds_vocabulary(enum_val);


--
-- Name: timeseries timeseries_station_id_0f4fed9c_fk_stationmeta_core_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_station_id_0f4fed9c_fk_stationmeta_core_id FOREIGN KEY (station_id) REFERENCES public.stationmeta_core(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: timeseries_timeseries_annotations timeseries_timeseries_annotations_annotation_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_timeseries_annotations
    ADD CONSTRAINT timeseries_timeseries_annotations_annotation_id_fkey FOREIGN KEY (annotation_id) REFERENCES public.timeseries_annotations(id);


--
-- Name: timeseries_timeseries_annotations timeseries_timeseries_annotations_timeseries_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_timeseries_annotations
    ADD CONSTRAINT timeseries_timeseries_annotations_timeseries_id_fkey FOREIGN KEY (timeseries_id) REFERENCES public.timeseries(id);


--
-- Name: timeseries_timeseries_roles timeseries_timeseries_roles_role_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_timeseries_roles
    ADD CONSTRAINT timeseries_timeseries_roles_role_id_fkey FOREIGN KEY (role_id) REFERENCES public.timeseries_roles(id);


--
-- Name: timeseries_timeseries_roles timeseries_timeseries_roles_timeseries_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries_timeseries_roles
    ADD CONSTRAINT timeseries_timeseries_roles_timeseries_id_fkey FOREIGN KEY (timeseries_id) REFERENCES public.timeseries(id);


--
-- Name: timeseries timeseries_variable_id_dd9603f5_fk_variables_id; Type: FK CONSTRAINT; Schema: public; Owner: toarcurator
--

ALTER TABLE ONLY public.timeseries
    ADD CONSTRAINT timeseries_variable_id_dd9603f5_fk_variables_id FOREIGN KEY (variable_id) REFERENCES public.variables(id) DEFERRABLE INITIALLY DEFERRED;


--
-- Name: SCHEMA postgis; Type: ACL; Schema: -; Owner: toarcurator
--

GRANT USAGE ON SCHEMA postgis TO toaruser;


--
-- Name: SCHEMA public; Type: ACL; Schema: -; Owner: postgres
--

GRANT USAGE ON SCHEMA public TO toaruser;


--
-- Name: FUNCTION raster_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_in(cstring) TO toaruser;


--
-- Name: FUNCTION raster_out(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_out(postgis.raster) TO toaruser;


--
-- Name: FUNCTION box2d_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box2d_in(cstring) TO toaruser;


--
-- Name: FUNCTION box2d_out(postgis.box2d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box2d_out(postgis.box2d) TO toaruser;


--
-- Name: FUNCTION box2df_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box2df_in(cstring) TO toaruser;


--
-- Name: FUNCTION box2df_out(postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box2df_out(postgis.box2df) TO toaruser;


--
-- Name: FUNCTION box3d_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box3d_in(cstring) TO toaruser;


--
-- Name: FUNCTION box3d_out(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box3d_out(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION geography_analyze(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_analyze(internal) TO toaruser;


--
-- Name: FUNCTION geography_in(cstring, oid, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_in(cstring, oid, integer) TO toaruser;


--
-- Name: FUNCTION geography_out(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_out(postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_recv(internal, oid, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_recv(internal, oid, integer) TO toaruser;


--
-- Name: FUNCTION geography_send(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_send(postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_typmod_in(cstring[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_typmod_in(cstring[]) TO toaruser;


--
-- Name: FUNCTION geography_typmod_out(integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_typmod_out(integer) TO toaruser;


--
-- Name: FUNCTION geometry_analyze(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_analyze(internal) TO toaruser;


--
-- Name: FUNCTION geometry_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_in(cstring) TO toaruser;


--
-- Name: FUNCTION geometry_out(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_out(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_recv(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_recv(internal) TO toaruser;


--
-- Name: FUNCTION geometry_send(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_send(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_typmod_in(cstring[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_typmod_in(cstring[]) TO toaruser;


--
-- Name: FUNCTION geometry_typmod_out(integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_typmod_out(integer) TO toaruser;


--
-- Name: FUNCTION gidx_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gidx_in(cstring) TO toaruser;


--
-- Name: FUNCTION gidx_out(postgis.gidx); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gidx_out(postgis.gidx) TO toaruser;


--
-- Name: FUNCTION pgis_abs_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_abs_in(cstring) TO toaruser;


--
-- Name: FUNCTION pgis_abs_out(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_abs_out(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION spheroid_in(cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.spheroid_in(cstring) TO toaruser;


--
-- Name: FUNCTION spheroid_out(postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.spheroid_out(postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION __st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.__st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION _add_overview_constraint(ovschema name, ovtable name, ovcolumn name, refschema name, reftable name, refcolumn name, factor integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_overview_constraint(ovschema name, ovtable name, ovcolumn name, refschema name, reftable name, refcolumn name, factor integer) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint(cn name, sql text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint(cn name, sql text) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_alignment(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_alignment(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_blocksize(rastschema name, rasttable name, rastcolumn name, axis text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_blocksize(rastschema name, rasttable name, rastcolumn name, axis text) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_coverage_tile(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_coverage_tile(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_extent(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_extent(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_nodata_values(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_nodata_values(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_num_bands(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_num_bands(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_out_db(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_out_db(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_pixel_types(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_pixel_types(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_scale(rastschema name, rasttable name, rastcolumn name, axis character); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_scale(rastschema name, rasttable name, rastcolumn name, axis character) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_spatially_unique(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_spatially_unique(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _add_raster_constraint_srid(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._add_raster_constraint_srid(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_overview_constraint(ovschema name, ovtable name, ovcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_overview_constraint(ovschema name, ovtable name, ovcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint(rastschema name, rasttable name, cn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint(rastschema name, rasttable name, cn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_alignment(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_alignment(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_blocksize(rastschema name, rasttable name, rastcolumn name, axis text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_blocksize(rastschema name, rasttable name, rastcolumn name, axis text) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_coverage_tile(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_coverage_tile(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_extent(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_extent(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_nodata_values(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_nodata_values(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_num_bands(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_num_bands(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_out_db(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_out_db(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_pixel_types(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_pixel_types(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_regular_blocking(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_regular_blocking(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_scale(rastschema name, rasttable name, rastcolumn name, axis character); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_scale(rastschema name, rasttable name, rastcolumn name, axis character) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_spatially_unique(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_spatially_unique(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _drop_raster_constraint_srid(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._drop_raster_constraint_srid(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _overview_constraint(ov postgis.raster, factor integer, refschema name, reftable name, refcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._overview_constraint(ov postgis.raster, factor integer, refschema name, reftable name, refcolumn name) TO toaruser;


--
-- Name: FUNCTION _overview_constraint_info(ovschema name, ovtable name, ovcolumn name, OUT refschema name, OUT reftable name, OUT refcolumn name, OUT factor integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._overview_constraint_info(ovschema name, ovtable name, ovcolumn name, OUT refschema name, OUT reftable name, OUT refcolumn name, OUT factor integer) TO toaruser;


--
-- Name: FUNCTION _postgis_deprecate(oldname text, newname text, version text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._postgis_deprecate(oldname text, newname text, version text) TO toaruser;


--
-- Name: FUNCTION _postgis_join_selectivity(regclass, text, regclass, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._postgis_join_selectivity(regclass, text, regclass, text, text) TO toaruser;


--
-- Name: FUNCTION _postgis_pgsql_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._postgis_pgsql_version() TO toaruser;


--
-- Name: FUNCTION _postgis_scripts_pgsql_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._postgis_scripts_pgsql_version() TO toaruser;


--
-- Name: FUNCTION _postgis_selectivity(tbl regclass, att_name text, geom postgis.geometry, mode text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._postgis_selectivity(tbl regclass, att_name text, geom postgis.geometry, mode text) TO toaruser;


--
-- Name: FUNCTION _postgis_stats(tbl regclass, att_name text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._postgis_stats(tbl regclass, att_name text, text) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_alignment(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_alignment(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_blocksize(rastschema name, rasttable name, rastcolumn name, axis text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_blocksize(rastschema name, rasttable name, rastcolumn name, axis text) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_coverage_tile(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_coverage_tile(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_extent(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_extent(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_index(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_index(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_nodata_values(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_nodata_values(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_num_bands(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_num_bands(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_out_db(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_out_db(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_pixel_types(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_pixel_types(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_regular_blocking(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_regular_blocking(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_scale(rastschema name, rasttable name, rastcolumn name, axis character); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_scale(rastschema name, rasttable name, rastcolumn name, axis character) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_spatially_unique(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_spatially_unique(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_info_srid(rastschema name, rasttable name, rastcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_info_srid(rastschema name, rasttable name, rastcolumn name) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_nodata_values(rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_nodata_values(rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_out_db(rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_out_db(rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION _raster_constraint_pixel_types(rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._raster_constraint_pixel_types(rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION _st_3ddfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_3ddfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION _st_3ddwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_3ddwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION _st_3dintersects(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_3dintersects(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_asgeojson(integer, postgis.geography, integer, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_asgeojson(integer, postgis.geography, integer, integer) TO toaruser;


--
-- Name: FUNCTION _st_asgeojson(integer, postgis.geometry, integer, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_asgeojson(integer, postgis.geometry, integer, integer) TO toaruser;


--
-- Name: FUNCTION _st_asgml(integer, postgis.geography, integer, integer, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_asgml(integer, postgis.geography, integer, integer, text, text) TO toaruser;


--
-- Name: FUNCTION _st_asgml(integer, postgis.geometry, integer, integer, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_asgml(integer, postgis.geometry, integer, integer, text, text) TO toaruser;


--
-- Name: FUNCTION _st_askml(integer, postgis.geography, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_askml(integer, postgis.geography, integer, text) TO toaruser;


--
-- Name: FUNCTION _st_askml(integer, postgis.geometry, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_askml(integer, postgis.geometry, integer, text) TO toaruser;


--
-- Name: FUNCTION _st_aspect4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_aspect4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, width integer, height integer, pixeltype text[], value double precision[], nodataval double precision[], upperleftx double precision, upperlefty double precision, gridx double precision, gridy double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, width integer, height integer, pixeltype text[], value double precision[], nodataval double precision[], upperleftx double precision, upperlefty double precision, gridx double precision, gridy double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION _st_asx3d(integer, postgis.geometry, integer, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_asx3d(integer, postgis.geometry, integer, integer, text) TO toaruser;


--
-- Name: FUNCTION _st_bestsrid(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_bestsrid(postgis.geography) TO toaruser;


--
-- Name: FUNCTION _st_bestsrid(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_bestsrid(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION _st_buffer(postgis.geometry, double precision, cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_buffer(postgis.geometry, double precision, cstring) TO toaruser;


--
-- Name: FUNCTION _st_clip(rast postgis.raster, nband integer[], geom postgis.geometry, nodataval double precision[], crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_clip(rast postgis.raster, nband integer[], geom postgis.geometry, nodataval double precision[], crop boolean) TO toaruser;


--
-- Name: FUNCTION _st_colormap(rast postgis.raster, nband integer, colormap text, method text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_colormap(rast postgis.raster, nband integer, colormap text, method text) TO toaruser;


--
-- Name: FUNCTION _st_concavehull(param_inputgeom postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_concavehull(param_inputgeom postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_contains(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_contains(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_contains(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_contains(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_containsproperly(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_containsproperly(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_containsproperly(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_containsproperly(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_convertarray4ma(value double precision[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_convertarray4ma(value double precision[]) TO toaruser;


--
-- Name: FUNCTION _st_count(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_count(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_count(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_count(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_countagg_finalfn(agg postgis.agg_count); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_countagg_finalfn(agg postgis.agg_count) TO toaruser;


--
-- Name: FUNCTION _st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION _st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, nband integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, nband integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION _st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_countagg_transfn(agg postgis.agg_count, rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_coveredby(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_coveredby(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_coveredby(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_coveredby(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_covers(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_covers(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION _st_covers(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_covers(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_covers(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_covers(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_crosses(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_crosses(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_dfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION _st_dfullywithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dfullywithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision) TO toaruser;


--
-- Name: FUNCTION _st_distance(postgis.geography, postgis.geography, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_distance(postgis.geography, postgis.geography, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION _st_distancetree(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_distancetree(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION _st_distancetree(postgis.geography, postgis.geography, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_distancetree(postgis.geography, postgis.geography, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION _st_distanceuncached(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_distanceuncached(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION _st_distanceuncached(postgis.geography, postgis.geography, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_distanceuncached(postgis.geography, postgis.geography, boolean) TO toaruser;


--
-- Name: FUNCTION _st_distanceuncached(postgis.geography, postgis.geography, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_distanceuncached(postgis.geography, postgis.geography, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION _st_dwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION _st_dwithin(postgis.geography, postgis.geography, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dwithin(postgis.geography, postgis.geography, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION _st_dwithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dwithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision) TO toaruser;


--
-- Name: FUNCTION _st_dwithinuncached(postgis.geography, postgis.geography, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dwithinuncached(postgis.geography, postgis.geography, double precision) TO toaruser;


--
-- Name: FUNCTION _st_dwithinuncached(postgis.geography, postgis.geography, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_dwithinuncached(postgis.geography, postgis.geography, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION _st_equals(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_equals(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_expand(postgis.geography, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_expand(postgis.geography, double precision) TO toaruser;


--
-- Name: FUNCTION _st_gdalwarp(rast postgis.raster, algorithm text, maxerr double precision, srid integer, scalex double precision, scaley double precision, gridx double precision, gridy double precision, skewx double precision, skewy double precision, width integer, height integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_gdalwarp(rast postgis.raster, algorithm text, maxerr double precision, srid integer, scalex double precision, scaley double precision, gridx double precision, gridy double precision, skewx double precision, skewy double precision, width integer, height integer) TO toaruser;


--
-- Name: FUNCTION _st_geomfromgml(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_geomfromgml(text, integer) TO toaruser;


--
-- Name: FUNCTION _st_hillshade4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_hillshade4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_histogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_histogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_histogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, min double precision, max double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_histogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, min double precision, max double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_intersects(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_intersects(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_intersects(geom postgis.geometry, rast postgis.raster, nband integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_intersects(geom postgis.geometry, rast postgis.raster, nband integer) TO toaruser;


--
-- Name: FUNCTION _st_intersects(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_intersects(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_linecrossingdirection(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_linecrossingdirection(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_longestline(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_longestline(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_mapalgebra(rastbandargset postgis.rastbandarg[], expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_mapalgebra(rastbandargset postgis.rastbandarg[], expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision) TO toaruser;


--
-- Name: FUNCTION _st_mapalgebra(rastbandargset postgis.rastbandarg[], callbackfunc regprocedure, pixeltype text, distancex integer, distancey integer, extenttype text, customextent postgis.raster, mask double precision[], weighted boolean, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_mapalgebra(rastbandargset postgis.rastbandarg[], callbackfunc regprocedure, pixeltype text, distancex integer, distancey integer, extenttype text, customextent postgis.raster, mask double precision[], weighted boolean, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_maxdistance(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_maxdistance(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_neighborhood(rast postgis.raster, band integer, columnx integer, rowy integer, distancex integer, distancey integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_neighborhood(rast postgis.raster, band integer, columnx integer, rowy integer, distancex integer, distancey integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION _st_orderingequals(geometrya postgis.geometry, geometryb postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_orderingequals(geometrya postgis.geometry, geometryb postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_overlaps(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_overlaps(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_overlaps(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_overlaps(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_pixelaspolygons(rast postgis.raster, band integer, columnx integer, rowy integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_pixelaspolygons(rast postgis.raster, band integer, columnx integer, rowy integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION _st_pointoutside(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_pointoutside(postgis.geography) TO toaruser;


--
-- Name: FUNCTION _st_quantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_quantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION _st_quantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_quantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION _st_rastertoworldcoord(rast postgis.raster, columnx integer, rowy integer, OUT longitude double precision, OUT latitude double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_rastertoworldcoord(rast postgis.raster, columnx integer, rowy integer, OUT longitude double precision, OUT latitude double precision) TO toaruser;


--
-- Name: FUNCTION _st_reclass(rast postgis.raster, VARIADIC reclassargset postgis.reclassarg[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_reclass(rast postgis.raster, VARIADIC reclassargset postgis.reclassarg[]) TO toaruser;


--
-- Name: FUNCTION _st_roughness4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_roughness4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_samealignment_finalfn(agg postgis.agg_samealignment); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_samealignment_finalfn(agg postgis.agg_samealignment) TO toaruser;


--
-- Name: FUNCTION _st_samealignment_transfn(agg postgis.agg_samealignment, rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_samealignment_transfn(agg postgis.agg_samealignment, rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION _st_setvalues(rast postgis.raster, nband integer, x integer, y integer, newvalueset double precision[], noset boolean[], hasnosetvalue boolean, nosetvalue double precision, keepnodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_setvalues(rast postgis.raster, nband integer, x integer, y integer, newvalueset double precision[], noset boolean[], hasnosetvalue boolean, nosetvalue double precision, keepnodata boolean) TO toaruser;


--
-- Name: FUNCTION _st_slope4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_slope4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_summarystats(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_summarystats(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_summarystats(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_summarystats(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_summarystats_finalfn(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_summarystats_finalfn(internal) TO toaruser;


--
-- Name: FUNCTION _st_summarystats_transfn(internal, postgis.raster, boolean, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_summarystats_transfn(internal, postgis.raster, boolean, double precision) TO toaruser;


--
-- Name: FUNCTION _st_summarystats_transfn(internal, postgis.raster, integer, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_summarystats_transfn(internal, postgis.raster, integer, boolean) TO toaruser;


--
-- Name: FUNCTION _st_summarystats_transfn(internal, postgis.raster, integer, boolean, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_summarystats_transfn(internal, postgis.raster, integer, boolean, double precision) TO toaruser;


--
-- Name: FUNCTION _st_tile(rast postgis.raster, width integer, height integer, nband integer[], padwithnodata boolean, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_tile(rast postgis.raster, width integer, height integer, nband integer[], padwithnodata boolean, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION _st_touches(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_touches(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_touches(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_touches(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_tpi4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_tpi4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_tri4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_tri4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION _st_union_finalfn(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_union_finalfn(internal) TO toaruser;


--
-- Name: FUNCTION _st_union_transfn(internal, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_union_transfn(internal, postgis.raster) TO toaruser;


--
-- Name: FUNCTION _st_union_transfn(internal, postgis.raster, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_union_transfn(internal, postgis.raster, integer) TO toaruser;


--
-- Name: FUNCTION _st_union_transfn(internal, postgis.raster, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_union_transfn(internal, postgis.raster, text) TO toaruser;


--
-- Name: FUNCTION _st_union_transfn(internal, postgis.raster, postgis.unionarg[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_union_transfn(internal, postgis.raster, postgis.unionarg[]) TO toaruser;


--
-- Name: FUNCTION _st_union_transfn(internal, postgis.raster, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_union_transfn(internal, postgis.raster, integer, text) TO toaruser;


--
-- Name: FUNCTION _st_valuecount(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_valuecount(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_valuecount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_valuecount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION _st_voronoi(g1 postgis.geometry, clip postgis.geometry, tolerance double precision, return_polygons boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_voronoi(g1 postgis.geometry, clip postgis.geometry, tolerance double precision, return_polygons boolean) TO toaruser;


--
-- Name: FUNCTION _st_within(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_within(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION _st_within(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_within(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION _st_worldtorastercoord(rast postgis.raster, longitude double precision, latitude double precision, OUT columnx integer, OUT rowy integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._st_worldtorastercoord(rast postgis.raster, longitude double precision, latitude double precision, OUT columnx integer, OUT rowy integer) TO toaruser;


--
-- Name: FUNCTION _updaterastersrid(schema_name name, table_name name, column_name name, new_srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis._updaterastersrid(schema_name name, table_name name, column_name name, new_srid integer) TO toaruser;


--
-- Name: FUNCTION addauth(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addauth(text) TO toaruser;


--
-- Name: FUNCTION addgeometrycolumn(table_name character varying, column_name character varying, new_srid integer, new_type character varying, new_dim integer, use_typmod boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addgeometrycolumn(table_name character varying, column_name character varying, new_srid integer, new_type character varying, new_dim integer, use_typmod boolean) TO toaruser;


--
-- Name: FUNCTION addgeometrycolumn(schema_name character varying, table_name character varying, column_name character varying, new_srid integer, new_type character varying, new_dim integer, use_typmod boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addgeometrycolumn(schema_name character varying, table_name character varying, column_name character varying, new_srid integer, new_type character varying, new_dim integer, use_typmod boolean) TO toaruser;


--
-- Name: FUNCTION addgeometrycolumn(catalog_name character varying, schema_name character varying, table_name character varying, column_name character varying, new_srid_in integer, new_type character varying, new_dim integer, use_typmod boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addgeometrycolumn(catalog_name character varying, schema_name character varying, table_name character varying, column_name character varying, new_srid_in integer, new_type character varying, new_dim integer, use_typmod boolean) TO toaruser;


--
-- Name: FUNCTION addoverviewconstraints(ovtable name, ovcolumn name, reftable name, refcolumn name, ovfactor integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addoverviewconstraints(ovtable name, ovcolumn name, reftable name, refcolumn name, ovfactor integer) TO toaruser;


--
-- Name: FUNCTION addoverviewconstraints(ovschema name, ovtable name, ovcolumn name, refschema name, reftable name, refcolumn name, ovfactor integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addoverviewconstraints(ovschema name, ovtable name, ovcolumn name, refschema name, reftable name, refcolumn name, ovfactor integer) TO toaruser;


--
-- Name: FUNCTION addrasterconstraints(rasttable name, rastcolumn name, VARIADIC constraints text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addrasterconstraints(rasttable name, rastcolumn name, VARIADIC constraints text[]) TO toaruser;


--
-- Name: FUNCTION addrasterconstraints(rastschema name, rasttable name, rastcolumn name, VARIADIC constraints text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addrasterconstraints(rastschema name, rasttable name, rastcolumn name, VARIADIC constraints text[]) TO toaruser;


--
-- Name: FUNCTION addrasterconstraints(rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addrasterconstraints(rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean) TO toaruser;


--
-- Name: FUNCTION addrasterconstraints(rastschema name, rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.addrasterconstraints(rastschema name, rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean) TO toaruser;


--
-- Name: FUNCTION box(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION box(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION box2d(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box2d(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION box2d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box2d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION box3d(postgis.box2d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box3d(postgis.box2d) TO toaruser;


--
-- Name: FUNCTION box3d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box3d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION box3d(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box3d(postgis.raster) TO toaruser;


--
-- Name: FUNCTION box3dtobox(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.box3dtobox(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION bytea(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.bytea(postgis.geography) TO toaruser;


--
-- Name: FUNCTION bytea(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.bytea(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION bytea(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.bytea(postgis.raster) TO toaruser;


--
-- Name: FUNCTION checkauth(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.checkauth(text, text) TO toaruser;


--
-- Name: FUNCTION checkauth(text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.checkauth(text, text, text) TO toaruser;


--
-- Name: FUNCTION checkauthtrigger(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.checkauthtrigger() TO toaruser;


--
-- Name: FUNCTION contains_2d(postgis.box2df, postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.contains_2d(postgis.box2df, postgis.box2df) TO toaruser;


--
-- Name: FUNCTION contains_2d(postgis.box2df, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.contains_2d(postgis.box2df, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION contains_2d(postgis.geometry, postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.contains_2d(postgis.geometry, postgis.box2df) TO toaruser;


--
-- Name: FUNCTION disablelongtransactions(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.disablelongtransactions() TO toaruser;


--
-- Name: FUNCTION dropgeometrycolumn(table_name character varying, column_name character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropgeometrycolumn(table_name character varying, column_name character varying) TO toaruser;


--
-- Name: FUNCTION dropgeometrycolumn(schema_name character varying, table_name character varying, column_name character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropgeometrycolumn(schema_name character varying, table_name character varying, column_name character varying) TO toaruser;


--
-- Name: FUNCTION dropgeometrycolumn(catalog_name character varying, schema_name character varying, table_name character varying, column_name character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropgeometrycolumn(catalog_name character varying, schema_name character varying, table_name character varying, column_name character varying) TO toaruser;


--
-- Name: FUNCTION dropgeometrytable(table_name character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropgeometrytable(table_name character varying) TO toaruser;


--
-- Name: FUNCTION dropgeometrytable(schema_name character varying, table_name character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropgeometrytable(schema_name character varying, table_name character varying) TO toaruser;


--
-- Name: FUNCTION dropgeometrytable(catalog_name character varying, schema_name character varying, table_name character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropgeometrytable(catalog_name character varying, schema_name character varying, table_name character varying) TO toaruser;


--
-- Name: FUNCTION dropoverviewconstraints(ovtable name, ovcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropoverviewconstraints(ovtable name, ovcolumn name) TO toaruser;


--
-- Name: FUNCTION dropoverviewconstraints(ovschema name, ovtable name, ovcolumn name); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.dropoverviewconstraints(ovschema name, ovtable name, ovcolumn name) TO toaruser;


--
-- Name: FUNCTION droprasterconstraints(rasttable name, rastcolumn name, VARIADIC constraints text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.droprasterconstraints(rasttable name, rastcolumn name, VARIADIC constraints text[]) TO toaruser;


--
-- Name: FUNCTION droprasterconstraints(rastschema name, rasttable name, rastcolumn name, VARIADIC constraints text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.droprasterconstraints(rastschema name, rasttable name, rastcolumn name, VARIADIC constraints text[]) TO toaruser;


--
-- Name: FUNCTION droprasterconstraints(rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.droprasterconstraints(rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean) TO toaruser;


--
-- Name: FUNCTION droprasterconstraints(rastschema name, rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.droprasterconstraints(rastschema name, rasttable name, rastcolumn name, srid boolean, scale_x boolean, scale_y boolean, blocksize_x boolean, blocksize_y boolean, same_alignment boolean, regular_blocking boolean, num_bands boolean, pixel_types boolean, nodata_values boolean, out_db boolean, extent boolean) TO toaruser;


--
-- Name: FUNCTION enablelongtransactions(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.enablelongtransactions() TO toaruser;


--
-- Name: FUNCTION equals(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.equals(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION find_srid(character varying, character varying, character varying); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.find_srid(character varying, character varying, character varying) TO toaruser;


--
-- Name: FUNCTION geog_brin_inclusion_add_value(internal, internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geog_brin_inclusion_add_value(internal, internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geography(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography(bytea) TO toaruser;


--
-- Name: FUNCTION geography(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geography(postgis.geography, integer, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography(postgis.geography, integer, boolean) TO toaruser;


--
-- Name: FUNCTION geography_cmp(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_cmp(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_distance_knn(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_distance_knn(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_eq(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_eq(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_ge(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_ge(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_gist_compress(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_compress(internal) TO toaruser;


--
-- Name: FUNCTION geography_gist_consistent(internal, postgis.geography, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_consistent(internal, postgis.geography, integer) TO toaruser;


--
-- Name: FUNCTION geography_gist_decompress(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_decompress(internal) TO toaruser;


--
-- Name: FUNCTION geography_gist_distance(internal, postgis.geography, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_distance(internal, postgis.geography, integer) TO toaruser;


--
-- Name: FUNCTION geography_gist_penalty(internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_penalty(internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geography_gist_picksplit(internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_picksplit(internal, internal) TO toaruser;


--
-- Name: FUNCTION geography_gist_same(postgis.box2d, postgis.box2d, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_same(postgis.box2d, postgis.box2d, internal) TO toaruser;


--
-- Name: FUNCTION geography_gist_union(bytea, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gist_union(bytea, internal) TO toaruser;


--
-- Name: FUNCTION geography_gt(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_gt(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_le(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_le(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_lt(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_lt(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geography_overlaps(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geography_overlaps(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION geom2d_brin_inclusion_add_value(internal, internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geom2d_brin_inclusion_add_value(internal, internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geom3d_brin_inclusion_add_value(internal, internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geom3d_brin_inclusion_add_value(internal, internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geom4d_brin_inclusion_add_value(internal, internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geom4d_brin_inclusion_add_value(internal, internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geometry(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(bytea) TO toaruser;


--
-- Name: FUNCTION geometry(path); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(path) TO toaruser;


--
-- Name: FUNCTION geometry(point); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(point) TO toaruser;


--
-- Name: FUNCTION geometry(polygon); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(polygon) TO toaruser;


--
-- Name: FUNCTION geometry(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(text) TO toaruser;


--
-- Name: FUNCTION geometry(postgis.box2d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(postgis.box2d) TO toaruser;


--
-- Name: FUNCTION geometry(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION geometry(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(postgis.geography) TO toaruser;


--
-- Name: FUNCTION geometry(postgis.geometry, integer, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry(postgis.geometry, integer, boolean) TO toaruser;


--
-- Name: FUNCTION geometry_above(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_above(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_below(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_below(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_cmp(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_cmp(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_contained_by_raster(postgis.geometry, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_contained_by_raster(postgis.geometry, postgis.raster) TO toaruser;


--
-- Name: FUNCTION geometry_contains(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_contains(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_distance_box(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_distance_box(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_distance_centroid(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_distance_centroid(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_distance_centroid_nd(postgis.geometry, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_distance_centroid_nd(postgis.geometry, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_distance_cpa(postgis.geometry, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_distance_cpa(postgis.geometry, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_eq(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_eq(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_ge(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_ge(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_gist_compress_2d(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_compress_2d(internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_compress_nd(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_compress_nd(internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_consistent_2d(internal, postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_consistent_2d(internal, postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION geometry_gist_consistent_nd(internal, postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_consistent_nd(internal, postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION geometry_gist_decompress_2d(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_decompress_2d(internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_decompress_nd(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_decompress_nd(internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_distance_2d(internal, postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_distance_2d(internal, postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION geometry_gist_distance_nd(internal, postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_distance_nd(internal, postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION geometry_gist_penalty_2d(internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_penalty_2d(internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_penalty_nd(internal, internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_penalty_nd(internal, internal, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_picksplit_2d(internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_picksplit_2d(internal, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_picksplit_nd(internal, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_picksplit_nd(internal, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_same_2d(geom1 postgis.geometry, geom2 postgis.geometry, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_same_2d(geom1 postgis.geometry, geom2 postgis.geometry, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_same_nd(postgis.geometry, postgis.geometry, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_same_nd(postgis.geometry, postgis.geometry, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_union_2d(bytea, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_union_2d(bytea, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gist_union_nd(bytea, internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gist_union_nd(bytea, internal) TO toaruser;


--
-- Name: FUNCTION geometry_gt(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_gt(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_le(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_le(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_left(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_left(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_lt(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_lt(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_overabove(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_overabove(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_overbelow(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_overbelow(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_overlaps(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_overlaps(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_overlaps_nd(postgis.geometry, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_overlaps_nd(postgis.geometry, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_overleft(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_overleft(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_overright(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_overright(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_raster_contain(postgis.geometry, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_raster_contain(postgis.geometry, postgis.raster) TO toaruser;


--
-- Name: FUNCTION geometry_raster_overlap(postgis.geometry, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_raster_overlap(postgis.geometry, postgis.raster) TO toaruser;


--
-- Name: FUNCTION geometry_right(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_right(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_same(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_same(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometry_within(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometry_within(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geometrytype(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometrytype(postgis.geography) TO toaruser;


--
-- Name: FUNCTION geometrytype(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geometrytype(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION geomfromewkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geomfromewkb(bytea) TO toaruser;


--
-- Name: FUNCTION geomfromewkt(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.geomfromewkt(text) TO toaruser;


--
-- Name: FUNCTION get_proj4_from_srid(integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.get_proj4_from_srid(integer) TO toaruser;


--
-- Name: FUNCTION gettransactionid(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gettransactionid() TO toaruser;


--
-- Name: FUNCTION gserialized_gist_joinsel_2d(internal, oid, internal, smallint); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gserialized_gist_joinsel_2d(internal, oid, internal, smallint) TO toaruser;


--
-- Name: FUNCTION gserialized_gist_joinsel_nd(internal, oid, internal, smallint); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gserialized_gist_joinsel_nd(internal, oid, internal, smallint) TO toaruser;


--
-- Name: FUNCTION gserialized_gist_sel_2d(internal, oid, internal, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gserialized_gist_sel_2d(internal, oid, internal, integer) TO toaruser;


--
-- Name: FUNCTION gserialized_gist_sel_nd(internal, oid, internal, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.gserialized_gist_sel_nd(internal, oid, internal, integer) TO toaruser;


--
-- Name: FUNCTION is_contained_2d(postgis.box2df, postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.is_contained_2d(postgis.box2df, postgis.box2df) TO toaruser;


--
-- Name: FUNCTION is_contained_2d(postgis.box2df, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.is_contained_2d(postgis.box2df, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION is_contained_2d(postgis.geometry, postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.is_contained_2d(postgis.geometry, postgis.box2df) TO toaruser;


--
-- Name: FUNCTION lockrow(text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.lockrow(text, text, text) TO toaruser;


--
-- Name: FUNCTION lockrow(text, text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.lockrow(text, text, text, text) TO toaruser;


--
-- Name: FUNCTION lockrow(text, text, text, timestamp without time zone); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.lockrow(text, text, text, timestamp without time zone) TO toaruser;


--
-- Name: FUNCTION lockrow(text, text, text, text, timestamp without time zone); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.lockrow(text, text, text, text, timestamp without time zone) TO toaruser;


--
-- Name: FUNCTION longtransactionsenabled(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.longtransactionsenabled() TO toaruser;


--
-- Name: FUNCTION overlaps_2d(postgis.box2df, postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_2d(postgis.box2df, postgis.box2df) TO toaruser;


--
-- Name: FUNCTION overlaps_2d(postgis.box2df, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_2d(postgis.box2df, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION overlaps_2d(postgis.geometry, postgis.box2df); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_2d(postgis.geometry, postgis.box2df) TO toaruser;


--
-- Name: FUNCTION overlaps_geog(postgis.geography, postgis.gidx); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_geog(postgis.geography, postgis.gidx) TO toaruser;


--
-- Name: FUNCTION overlaps_geog(postgis.gidx, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_geog(postgis.gidx, postgis.geography) TO toaruser;


--
-- Name: FUNCTION overlaps_geog(postgis.gidx, postgis.gidx); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_geog(postgis.gidx, postgis.gidx) TO toaruser;


--
-- Name: FUNCTION overlaps_nd(postgis.geometry, postgis.gidx); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_nd(postgis.geometry, postgis.gidx) TO toaruser;


--
-- Name: FUNCTION overlaps_nd(postgis.gidx, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_nd(postgis.gidx, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION overlaps_nd(postgis.gidx, postgis.gidx); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.overlaps_nd(postgis.gidx, postgis.gidx) TO toaruser;


--
-- Name: FUNCTION path(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.path(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION pgis_asgeobuf_finalfn(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asgeobuf_finalfn(internal) TO toaruser;


--
-- Name: FUNCTION pgis_asgeobuf_transfn(internal, anyelement); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asgeobuf_transfn(internal, anyelement) TO toaruser;


--
-- Name: FUNCTION pgis_asgeobuf_transfn(internal, anyelement, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asgeobuf_transfn(internal, anyelement, text) TO toaruser;


--
-- Name: FUNCTION pgis_asmvt_finalfn(internal); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asmvt_finalfn(internal) TO toaruser;


--
-- Name: FUNCTION pgis_asmvt_transfn(internal, anyelement); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asmvt_transfn(internal, anyelement) TO toaruser;


--
-- Name: FUNCTION pgis_asmvt_transfn(internal, anyelement, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asmvt_transfn(internal, anyelement, text) TO toaruser;


--
-- Name: FUNCTION pgis_asmvt_transfn(internal, anyelement, text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asmvt_transfn(internal, anyelement, text, integer) TO toaruser;


--
-- Name: FUNCTION pgis_asmvt_transfn(internal, anyelement, text, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_asmvt_transfn(internal, anyelement, text, integer, text) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_accum_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_accum_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_accum_transfn(postgis.pgis_abs, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_accum_transfn(postgis.pgis_abs, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_accum_transfn(postgis.pgis_abs, postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_accum_transfn(postgis.pgis_abs, postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_accum_transfn(postgis.pgis_abs, postgis.geometry, double precision, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_accum_transfn(postgis.pgis_abs, postgis.geometry, double precision, integer) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_clusterintersecting_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_clusterintersecting_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_clusterwithin_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_clusterwithin_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_collect_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_collect_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_makeline_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_makeline_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_polygonize_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_polygonize_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION pgis_geometry_union_finalfn(postgis.pgis_abs); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.pgis_geometry_union_finalfn(postgis.pgis_abs) TO toaruser;


--
-- Name: FUNCTION point(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.point(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION polygon(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.polygon(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION populate_geometry_columns(use_typmod boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.populate_geometry_columns(use_typmod boolean) TO toaruser;


--
-- Name: FUNCTION populate_geometry_columns(tbl_oid oid, use_typmod boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.populate_geometry_columns(tbl_oid oid, use_typmod boolean) TO toaruser;


--
-- Name: FUNCTION postgis_addbbox(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_addbbox(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION postgis_cache_bbox(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_cache_bbox() TO toaruser;


--
-- Name: FUNCTION postgis_constraint_dims(geomschema text, geomtable text, geomcolumn text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_constraint_dims(geomschema text, geomtable text, geomcolumn text) TO toaruser;


--
-- Name: FUNCTION postgis_constraint_srid(geomschema text, geomtable text, geomcolumn text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_constraint_srid(geomschema text, geomtable text, geomcolumn text) TO toaruser;


--
-- Name: FUNCTION postgis_constraint_type(geomschema text, geomtable text, geomcolumn text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_constraint_type(geomschema text, geomtable text, geomcolumn text) TO toaruser;


--
-- Name: FUNCTION postgis_dropbbox(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_dropbbox(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION postgis_full_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_full_version() TO toaruser;


--
-- Name: FUNCTION postgis_gdal_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_gdal_version() TO toaruser;


--
-- Name: FUNCTION postgis_geos_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_geos_version() TO toaruser;


--
-- Name: FUNCTION postgis_getbbox(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_getbbox(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION postgis_hasbbox(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_hasbbox(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION postgis_lib_build_date(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_lib_build_date() TO toaruser;


--
-- Name: FUNCTION postgis_lib_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_lib_version() TO toaruser;


--
-- Name: FUNCTION postgis_libjson_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_libjson_version() TO toaruser;


--
-- Name: FUNCTION postgis_liblwgeom_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_liblwgeom_version() TO toaruser;


--
-- Name: FUNCTION postgis_libprotobuf_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_libprotobuf_version() TO toaruser;


--
-- Name: FUNCTION postgis_libxml_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_libxml_version() TO toaruser;


--
-- Name: FUNCTION postgis_noop(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_noop(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION postgis_noop(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_noop(postgis.raster) TO toaruser;


--
-- Name: FUNCTION postgis_proj_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_proj_version() TO toaruser;


--
-- Name: FUNCTION postgis_raster_lib_build_date(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_raster_lib_build_date() TO toaruser;


--
-- Name: FUNCTION postgis_raster_lib_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_raster_lib_version() TO toaruser;


--
-- Name: FUNCTION postgis_raster_scripts_installed(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_raster_scripts_installed() TO toaruser;


--
-- Name: FUNCTION postgis_scripts_build_date(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_scripts_build_date() TO toaruser;


--
-- Name: FUNCTION postgis_scripts_installed(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_scripts_installed() TO toaruser;


--
-- Name: FUNCTION postgis_scripts_released(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_scripts_released() TO toaruser;


--
-- Name: FUNCTION postgis_svn_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_svn_version() TO toaruser;


--
-- Name: FUNCTION postgis_transform_geometry(postgis.geometry, text, text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_transform_geometry(postgis.geometry, text, text, integer) TO toaruser;


--
-- Name: FUNCTION postgis_type_name(geomname character varying, coord_dimension integer, use_new_name boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_type_name(geomname character varying, coord_dimension integer, use_new_name boolean) TO toaruser;


--
-- Name: FUNCTION postgis_typmod_dims(integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_typmod_dims(integer) TO toaruser;


--
-- Name: FUNCTION postgis_typmod_srid(integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_typmod_srid(integer) TO toaruser;


--
-- Name: FUNCTION postgis_typmod_type(integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_typmod_type(integer) TO toaruser;


--
-- Name: FUNCTION postgis_version(); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.postgis_version() TO toaruser;


--
-- Name: FUNCTION raster_above(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_above(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_below(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_below(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_contain(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_contain(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_contained(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_contained(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_contained_by_geometry(postgis.raster, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_contained_by_geometry(postgis.raster, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION raster_eq(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_eq(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_geometry_contain(postgis.raster, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_geometry_contain(postgis.raster, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION raster_geometry_overlap(postgis.raster, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_geometry_overlap(postgis.raster, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION raster_hash(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_hash(postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_left(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_left(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_overabove(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_overabove(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_overbelow(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_overbelow(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_overlap(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_overlap(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_overleft(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_overleft(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_overright(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_overright(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_right(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_right(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION raster_same(postgis.raster, postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.raster_same(postgis.raster, postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_3dclosestpoint(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dclosestpoint(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3ddfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3ddfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_3ddistance(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3ddistance(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3ddwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3ddwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_3dintersects(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dintersects(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3dlength(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dlength(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3dlength_spheroid(postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dlength_spheroid(postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_3dlongestline(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dlongestline(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3dmakebox(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dmakebox(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3dmaxdistance(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dmaxdistance(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3dperimeter(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dperimeter(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_3dshortestline(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dshortestline(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_addband(rast postgis.raster, addbandargset postgis.addbandarg[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(rast postgis.raster, addbandargset postgis.addbandarg[]) TO toaruser;


--
-- Name: FUNCTION st_addband(rast postgis.raster, pixeltype text, initialvalue double precision, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(rast postgis.raster, pixeltype text, initialvalue double precision, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_addband(torast postgis.raster, fromrasts postgis.raster[], fromband integer, torastindex integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(torast postgis.raster, fromrasts postgis.raster[], fromband integer, torastindex integer) TO toaruser;


--
-- Name: FUNCTION st_addband(torast postgis.raster, fromrast postgis.raster, fromband integer, torastindex integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(torast postgis.raster, fromrast postgis.raster, fromband integer, torastindex integer) TO toaruser;


--
-- Name: FUNCTION st_addband(rast postgis.raster, index integer, outdbfile text, outdbindex integer[], nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(rast postgis.raster, index integer, outdbfile text, outdbindex integer[], nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_addband(rast postgis.raster, index integer, pixeltype text, initialvalue double precision, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(rast postgis.raster, index integer, pixeltype text, initialvalue double precision, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_addband(rast postgis.raster, outdbfile text, outdbindex integer[], index integer, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addband(rast postgis.raster, outdbfile text, outdbindex integer[], index integer, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_addmeasure(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addmeasure(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_addpoint(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addpoint(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_addpoint(geom1 postgis.geometry, geom2 postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_addpoint(geom1 postgis.geometry, geom2 postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_affine(postgis.geometry, double precision, double precision, double precision, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_affine(postgis.geometry, double precision, double precision, double precision, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_affine(postgis.geometry, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_affine(postgis.geometry, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rast postgis.raster, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rast postgis.raster, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rastertable text, rastercolumn text, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rastertable text, rastercolumn text, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rast postgis.raster, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rast postgis.raster, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rast postgis.raster, nband integer, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rast postgis.raster, nband integer, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rastertable text, rastercolumn text, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rastertable text, rastercolumn text, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rastertable text, rastercolumn text, nband integer, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rastertable text, rastercolumn text, nband integer, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxcount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxcount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rast postgis.raster, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rast postgis.raster, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rastertable text, rastercolumn text, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rastertable text, rastercolumn text, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rast postgis.raster, nband integer, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rast postgis.raster, nband integer, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rastertable text, rastercolumn text, nband integer, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rastertable text, rastercolumn text, nband integer, sample_percent double precision, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rast postgis.raster, nband integer, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rast postgis.raster, nband integer, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rastertable text, rastercolumn text, nband integer, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rastertable text, rastercolumn text, nband integer, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rast postgis.raster, nband integer, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rast postgis.raster, nband integer, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rastertable text, rastercolumn text, nband integer, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rastertable text, rastercolumn text, nband integer, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxhistogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxhistogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, exclude_nodata_value boolean, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, exclude_nodata_value boolean, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, sample_percent double precision, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, sample_percent double precision, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, exclude_nodata_value boolean, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, exclude_nodata_value boolean, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, sample_percent double precision, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, sample_percent double precision, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, nband integer, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, nband integer, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, nband integer, sample_percent double precision, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, nband integer, sample_percent double precision, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, nband integer, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, nband integer, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, nband integer, sample_percent double precision, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, nband integer, sample_percent double precision, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_approxquantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxquantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rast postgis.raster, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rast postgis.raster, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rastertable text, rastercolumn text, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rastertable text, rastercolumn text, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rastertable text, rastercolumn text, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rastertable text, rastercolumn text, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rast postgis.raster, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rast postgis.raster, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rast postgis.raster, nband integer, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rast postgis.raster, nband integer, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rastertable text, rastercolumn text, nband integer, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rastertable text, rastercolumn text, nband integer, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rast postgis.raster, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_approxsummarystats(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_approxsummarystats(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, sample_percent double precision) TO toaruser;


--
-- Name: FUNCTION st_area(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_area(text) TO toaruser;


--
-- Name: FUNCTION st_area(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_area(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_area(geog postgis.geography, use_spheroid boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_area(geog postgis.geography, use_spheroid boolean) TO toaruser;


--
-- Name: FUNCTION st_area2d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_area2d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_asbinary(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asbinary(postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_asbinary(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asbinary(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_asbinary(postgis.geography, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asbinary(postgis.geography, text) TO toaruser;


--
-- Name: FUNCTION st_asbinary(postgis.geometry, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asbinary(postgis.geometry, text) TO toaruser;


--
-- Name: FUNCTION st_asbinary(postgis.raster, outasin boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asbinary(postgis.raster, outasin boolean) TO toaruser;


--
-- Name: FUNCTION st_asencodedpolyline(geom postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asencodedpolyline(geom postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_asewkb(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asewkb(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_asewkb(postgis.geometry, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asewkb(postgis.geometry, text) TO toaruser;


--
-- Name: FUNCTION st_asewkt(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asewkt(text) TO toaruser;


--
-- Name: FUNCTION st_asewkt(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asewkt(postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_asewkt(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asewkt(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_asgdalraster(rast postgis.raster, format text, options text[], srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgdalraster(rast postgis.raster, format text, options text[], srid integer) TO toaruser;


--
-- Name: FUNCTION st_asgeojson(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeojson(text) TO toaruser;


--
-- Name: FUNCTION st_asgeojson(geog postgis.geography, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeojson(geog postgis.geography, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_asgeojson(geom postgis.geometry, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeojson(geom postgis.geometry, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_asgeojson(gj_version integer, geog postgis.geography, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeojson(gj_version integer, geog postgis.geography, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_asgeojson(gj_version integer, geom postgis.geometry, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeojson(gj_version integer, geom postgis.geometry, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_asgml(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgml(text) TO toaruser;


--
-- Name: FUNCTION st_asgml(geog postgis.geography, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgml(geog postgis.geography, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_asgml(geom postgis.geometry, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgml(geom postgis.geometry, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_asgml(version integer, geog postgis.geography, maxdecimaldigits integer, options integer, nprefix text, id text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgml(version integer, geog postgis.geography, maxdecimaldigits integer, options integer, nprefix text, id text) TO toaruser;


--
-- Name: FUNCTION st_asgml(version integer, geom postgis.geometry, maxdecimaldigits integer, options integer, nprefix text, id text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgml(version integer, geom postgis.geometry, maxdecimaldigits integer, options integer, nprefix text, id text) TO toaruser;


--
-- Name: FUNCTION st_ashexewkb(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ashexewkb(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_ashexewkb(postgis.geometry, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ashexewkb(postgis.geometry, text) TO toaruser;


--
-- Name: FUNCTION st_asjpeg(rast postgis.raster, options text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asjpeg(rast postgis.raster, options text[]) TO toaruser;


--
-- Name: FUNCTION st_asjpeg(rast postgis.raster, nbands integer[], options text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asjpeg(rast postgis.raster, nbands integer[], options text[]) TO toaruser;


--
-- Name: FUNCTION st_asjpeg(rast postgis.raster, nbands integer[], quality integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asjpeg(rast postgis.raster, nbands integer[], quality integer) TO toaruser;


--
-- Name: FUNCTION st_asjpeg(rast postgis.raster, nband integer, options text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asjpeg(rast postgis.raster, nband integer, options text[]) TO toaruser;


--
-- Name: FUNCTION st_asjpeg(rast postgis.raster, nband integer, quality integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asjpeg(rast postgis.raster, nband integer, quality integer) TO toaruser;


--
-- Name: FUNCTION st_askml(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_askml(text) TO toaruser;


--
-- Name: FUNCTION st_askml(geog postgis.geography, maxdecimaldigits integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_askml(geog postgis.geography, maxdecimaldigits integer) TO toaruser;


--
-- Name: FUNCTION st_askml(geom postgis.geometry, maxdecimaldigits integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_askml(geom postgis.geometry, maxdecimaldigits integer) TO toaruser;


--
-- Name: FUNCTION st_askml(version integer, geog postgis.geography, maxdecimaldigits integer, nprefix text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_askml(version integer, geog postgis.geography, maxdecimaldigits integer, nprefix text) TO toaruser;


--
-- Name: FUNCTION st_askml(version integer, geom postgis.geometry, maxdecimaldigits integer, nprefix text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_askml(version integer, geom postgis.geometry, maxdecimaldigits integer, nprefix text) TO toaruser;


--
-- Name: FUNCTION st_aslatlontext(geom postgis.geometry, tmpl text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aslatlontext(geom postgis.geometry, tmpl text) TO toaruser;


--
-- Name: FUNCTION st_asmvtgeom(geom postgis.geometry, bounds postgis.box2d, extent integer, buffer integer, clip_geom boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asmvtgeom(geom postgis.geometry, bounds postgis.box2d, extent integer, buffer integer, clip_geom boolean) TO toaruser;


--
-- Name: FUNCTION st_aspect(rast postgis.raster, nband integer, pixeltype text, units text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspect(rast postgis.raster, nband integer, pixeltype text, units text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_aspect(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, units text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspect(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, units text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_aspng(rast postgis.raster, options text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspng(rast postgis.raster, options text[]) TO toaruser;


--
-- Name: FUNCTION st_aspng(rast postgis.raster, nbands integer[], options text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspng(rast postgis.raster, nbands integer[], options text[]) TO toaruser;


--
-- Name: FUNCTION st_aspng(rast postgis.raster, nbands integer[], compression integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspng(rast postgis.raster, nbands integer[], compression integer) TO toaruser;


--
-- Name: FUNCTION st_aspng(rast postgis.raster, nband integer, options text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspng(rast postgis.raster, nband integer, options text[]) TO toaruser;


--
-- Name: FUNCTION st_aspng(rast postgis.raster, nband integer, compression integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_aspng(rast postgis.raster, nband integer, compression integer) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, ref postgis.raster, pixeltype text[], value double precision[], nodataval double precision[], touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, ref postgis.raster, pixeltype text[], value double precision[], nodataval double precision[], touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, ref postgis.raster, pixeltype text, value double precision, nodataval double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, ref postgis.raster, pixeltype text, value double precision, nodataval double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, pixeltype text[], value double precision[], nodataval double precision[], upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, pixeltype text[], value double precision[], nodataval double precision[], upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, gridx double precision, gridy double precision, pixeltype text[], value double precision[], nodataval double precision[], skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, gridx double precision, gridy double precision, pixeltype text[], value double precision[], nodataval double precision[], skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, gridx double precision, gridy double precision, pixeltype text, value double precision, nodataval double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, gridx double precision, gridy double precision, pixeltype text, value double precision, nodataval double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, pixeltype text, value double precision, nodataval double precision, upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, scalex double precision, scaley double precision, pixeltype text, value double precision, nodataval double precision, upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, width integer, height integer, pixeltype text[], value double precision[], nodataval double precision[], upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, width integer, height integer, pixeltype text[], value double precision[], nodataval double precision[], upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, width integer, height integer, gridx double precision, gridy double precision, pixeltype text[], value double precision[], nodataval double precision[], skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, width integer, height integer, gridx double precision, gridy double precision, pixeltype text[], value double precision[], nodataval double precision[], skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, width integer, height integer, gridx double precision, gridy double precision, pixeltype text, value double precision, nodataval double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, width integer, height integer, gridx double precision, gridy double precision, pixeltype text, value double precision, nodataval double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_asraster(geom postgis.geometry, width integer, height integer, pixeltype text, value double precision, nodataval double precision, upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asraster(geom postgis.geometry, width integer, height integer, pixeltype text, value double precision, nodataval double precision, upperleftx double precision, upperlefty double precision, skewx double precision, skewy double precision, touched boolean) TO toaruser;


--
-- Name: FUNCTION st_assvg(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_assvg(text) TO toaruser;


--
-- Name: FUNCTION st_assvg(geog postgis.geography, rel integer, maxdecimaldigits integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_assvg(geog postgis.geography, rel integer, maxdecimaldigits integer) TO toaruser;


--
-- Name: FUNCTION st_assvg(geom postgis.geometry, rel integer, maxdecimaldigits integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_assvg(geom postgis.geometry, rel integer, maxdecimaldigits integer) TO toaruser;


--
-- Name: FUNCTION st_astext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astext(text) TO toaruser;


--
-- Name: FUNCTION st_astext(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astext(postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_astext(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astext(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_astiff(rast postgis.raster, options text[], srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astiff(rast postgis.raster, options text[], srid integer) TO toaruser;


--
-- Name: FUNCTION st_astiff(rast postgis.raster, compression text, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astiff(rast postgis.raster, compression text, srid integer) TO toaruser;


--
-- Name: FUNCTION st_astiff(rast postgis.raster, nbands integer[], options text[], srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astiff(rast postgis.raster, nbands integer[], options text[], srid integer) TO toaruser;


--
-- Name: FUNCTION st_astiff(rast postgis.raster, nbands integer[], compression text, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astiff(rast postgis.raster, nbands integer[], compression text, srid integer) TO toaruser;


--
-- Name: FUNCTION st_astwkb(geom postgis.geometry, prec integer, prec_z integer, prec_m integer, with_sizes boolean, with_boxes boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astwkb(geom postgis.geometry, prec integer, prec_z integer, prec_m integer, with_sizes boolean, with_boxes boolean) TO toaruser;


--
-- Name: FUNCTION st_astwkb(geom postgis.geometry[], ids bigint[], prec integer, prec_z integer, prec_m integer, with_sizes boolean, with_boxes boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_astwkb(geom postgis.geometry[], ids bigint[], prec integer, prec_z integer, prec_m integer, with_sizes boolean, with_boxes boolean) TO toaruser;


--
-- Name: FUNCTION st_asx3d(geom postgis.geometry, maxdecimaldigits integer, options integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asx3d(geom postgis.geometry, maxdecimaldigits integer, options integer) TO toaruser;


--
-- Name: FUNCTION st_azimuth(geog1 postgis.geography, geog2 postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_azimuth(geog1 postgis.geography, geog2 postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_azimuth(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_azimuth(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_band(rast postgis.raster, nbands integer[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_band(rast postgis.raster, nbands integer[]) TO toaruser;


--
-- Name: FUNCTION st_band(rast postgis.raster, nband integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_band(rast postgis.raster, nband integer) TO toaruser;


--
-- Name: FUNCTION st_band(rast postgis.raster, nbands text, delimiter character); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_band(rast postgis.raster, nbands text, delimiter character) TO toaruser;


--
-- Name: FUNCTION st_bandisnodata(rast postgis.raster, forcechecking boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandisnodata(rast postgis.raster, forcechecking boolean) TO toaruser;


--
-- Name: FUNCTION st_bandisnodata(rast postgis.raster, band integer, forcechecking boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandisnodata(rast postgis.raster, band integer, forcechecking boolean) TO toaruser;


--
-- Name: FUNCTION st_bandmetadata(rast postgis.raster, band integer[], OUT bandnum integer, OUT pixeltype text, OUT nodatavalue double precision, OUT isoutdb boolean, OUT path text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandmetadata(rast postgis.raster, band integer[], OUT bandnum integer, OUT pixeltype text, OUT nodatavalue double precision, OUT isoutdb boolean, OUT path text) TO toaruser;


--
-- Name: FUNCTION st_bandmetadata(rast postgis.raster, band integer, OUT pixeltype text, OUT nodatavalue double precision, OUT isoutdb boolean, OUT path text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandmetadata(rast postgis.raster, band integer, OUT pixeltype text, OUT nodatavalue double precision, OUT isoutdb boolean, OUT path text) TO toaruser;


--
-- Name: FUNCTION st_bandnodatavalue(rast postgis.raster, band integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandnodatavalue(rast postgis.raster, band integer) TO toaruser;


--
-- Name: FUNCTION st_bandpath(rast postgis.raster, band integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandpath(rast postgis.raster, band integer) TO toaruser;


--
-- Name: FUNCTION st_bandpixeltype(rast postgis.raster, band integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bandpixeltype(rast postgis.raster, band integer) TO toaruser;


--
-- Name: FUNCTION st_bdmpolyfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bdmpolyfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_bdpolyfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_bdpolyfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_boundary(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_boundary(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_boundingdiagonal(geom postgis.geometry, fits boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_boundingdiagonal(geom postgis.geometry, fits boolean) TO toaruser;


--
-- Name: FUNCTION st_box2dfromgeohash(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_box2dfromgeohash(text, integer) TO toaruser;


--
-- Name: FUNCTION st_buffer(text, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(text, double precision) TO toaruser;


--
-- Name: FUNCTION st_buffer(postgis.geography, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(postgis.geography, double precision) TO toaruser;


--
-- Name: FUNCTION st_buffer(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_buffer(text, double precision, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(text, double precision, integer) TO toaruser;


--
-- Name: FUNCTION st_buffer(text, double precision, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(text, double precision, text) TO toaruser;


--
-- Name: FUNCTION st_buffer(postgis.geography, double precision, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(postgis.geography, double precision, integer) TO toaruser;


--
-- Name: FUNCTION st_buffer(postgis.geography, double precision, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(postgis.geography, double precision, text) TO toaruser;


--
-- Name: FUNCTION st_buffer(postgis.geometry, double precision, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(postgis.geometry, double precision, integer) TO toaruser;


--
-- Name: FUNCTION st_buffer(postgis.geometry, double precision, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buffer(postgis.geometry, double precision, text) TO toaruser;


--
-- Name: FUNCTION st_buildarea(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_buildarea(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_centroid(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_centroid(text) TO toaruser;


--
-- Name: FUNCTION st_centroid(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_centroid(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_centroid(postgis.geography, use_spheroid boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_centroid(postgis.geography, use_spheroid boolean) TO toaruser;


--
-- Name: FUNCTION st_cleangeometry(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_cleangeometry(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_clip(rast postgis.raster, geom postgis.geometry, crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clip(rast postgis.raster, geom postgis.geometry, crop boolean) TO toaruser;


--
-- Name: FUNCTION st_clip(rast postgis.raster, nband integer, geom postgis.geometry, crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clip(rast postgis.raster, nband integer, geom postgis.geometry, crop boolean) TO toaruser;


--
-- Name: FUNCTION st_clip(rast postgis.raster, geom postgis.geometry, nodataval double precision[], crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clip(rast postgis.raster, geom postgis.geometry, nodataval double precision[], crop boolean) TO toaruser;


--
-- Name: FUNCTION st_clip(rast postgis.raster, geom postgis.geometry, nodataval double precision, crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clip(rast postgis.raster, geom postgis.geometry, nodataval double precision, crop boolean) TO toaruser;


--
-- Name: FUNCTION st_clip(rast postgis.raster, nband integer[], geom postgis.geometry, nodataval double precision[], crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clip(rast postgis.raster, nband integer[], geom postgis.geometry, nodataval double precision[], crop boolean) TO toaruser;


--
-- Name: FUNCTION st_clip(rast postgis.raster, nband integer, geom postgis.geometry, nodataval double precision, crop boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clip(rast postgis.raster, nband integer, geom postgis.geometry, nodataval double precision, crop boolean) TO toaruser;


--
-- Name: FUNCTION st_clipbybox2d(geom postgis.geometry, box postgis.box2d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clipbybox2d(geom postgis.geometry, box postgis.box2d) TO toaruser;


--
-- Name: FUNCTION st_closestpoint(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_closestpoint(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_closestpointofapproach(postgis.geometry, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_closestpointofapproach(postgis.geometry, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_clusterdbscan(postgis.geometry, eps double precision, minpoints integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clusterdbscan(postgis.geometry, eps double precision, minpoints integer) TO toaruser;


--
-- Name: FUNCTION st_clusterintersecting(postgis.geometry[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clusterintersecting(postgis.geometry[]) TO toaruser;


--
-- Name: FUNCTION st_clusterkmeans(geom postgis.geometry, k integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clusterkmeans(geom postgis.geometry, k integer) TO toaruser;


--
-- Name: FUNCTION st_clusterwithin(postgis.geometry[], double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clusterwithin(postgis.geometry[], double precision) TO toaruser;


--
-- Name: FUNCTION st_collect(postgis.geometry[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_collect(postgis.geometry[]) TO toaruser;


--
-- Name: FUNCTION st_collect(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_collect(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_collectionextract(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_collectionextract(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_collectionhomogenize(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_collectionhomogenize(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_colormap(rast postgis.raster, colormap text, method text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_colormap(rast postgis.raster, colormap text, method text) TO toaruser;


--
-- Name: FUNCTION st_colormap(rast postgis.raster, nband integer, colormap text, method text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_colormap(rast postgis.raster, nband integer, colormap text, method text) TO toaruser;


--
-- Name: FUNCTION st_combine_bbox(postgis.box2d, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_combine_bbox(postgis.box2d, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_combine_bbox(postgis.box3d, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_combine_bbox(postgis.box3d, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_combinebbox(postgis.box2d, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_combinebbox(postgis.box2d, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_combinebbox(postgis.box3d, postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_combinebbox(postgis.box3d, postgis.box3d) TO toaruser;


--
-- Name: FUNCTION st_combinebbox(postgis.box3d, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_combinebbox(postgis.box3d, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_concavehull(param_geom postgis.geometry, param_pctconvex double precision, param_allow_holes boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_concavehull(param_geom postgis.geometry, param_pctconvex double precision, param_allow_holes boolean) TO toaruser;


--
-- Name: FUNCTION st_contains(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_contains(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_contains(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_contains(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_contains(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_contains(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_containsproperly(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_containsproperly(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_containsproperly(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_containsproperly(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_containsproperly(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_containsproperly(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_convexhull(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_convexhull(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_convexhull(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_convexhull(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_coorddim(geometry postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_coorddim(geometry postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_count(rast postgis.raster, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_count(rast postgis.raster, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_count(rastertable text, rastercolumn text, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_count(rastertable text, rastercolumn text, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_count(rast postgis.raster, nband integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_count(rast postgis.raster, nband integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_count(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_count(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_coveredby(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_coveredby(text, text) TO toaruser;


--
-- Name: FUNCTION st_coveredby(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_coveredby(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_coveredby(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_coveredby(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_coveredby(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_coveredby(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_coveredby(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_coveredby(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_covers(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_covers(text, text) TO toaruser;


--
-- Name: FUNCTION st_covers(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_covers(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_covers(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_covers(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_covers(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_covers(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_covers(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_covers(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_cpawithin(postgis.geometry, postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_cpawithin(postgis.geometry, postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_createoverview(tab regclass, col name, factor integer, algo text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_createoverview(tab regclass, col name, factor integer, algo text) TO toaruser;


--
-- Name: FUNCTION st_crosses(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_crosses(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_curvetoline(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_curvetoline(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_curvetoline(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_curvetoline(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_curvetoline(geom postgis.geometry, tol double precision, toltype integer, flags integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_curvetoline(geom postgis.geometry, tol double precision, toltype integer, flags integer) TO toaruser;


--
-- Name: FUNCTION st_delaunaytriangles(g1 postgis.geometry, tolerance double precision, flags integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_delaunaytriangles(g1 postgis.geometry, tolerance double precision, flags integer) TO toaruser;


--
-- Name: FUNCTION st_dfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dfullywithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_dfullywithin(rast1 postgis.raster, rast2 postgis.raster, distance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dfullywithin(rast1 postgis.raster, rast2 postgis.raster, distance double precision) TO toaruser;


--
-- Name: FUNCTION st_dfullywithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dfullywithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision) TO toaruser;


--
-- Name: FUNCTION st_difference(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_difference(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_dimension(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dimension(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_disjoint(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_disjoint(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_disjoint(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_disjoint(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_disjoint(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_disjoint(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_distance(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distance(text, text) TO toaruser;


--
-- Name: FUNCTION st_distance(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distance(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_distance(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distance(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_distance(postgis.geography, postgis.geography, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distance(postgis.geography, postgis.geography, boolean) TO toaruser;


--
-- Name: FUNCTION st_distance_sphere(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distance_sphere(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_distance_spheroid(geom1 postgis.geometry, geom2 postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distance_spheroid(geom1 postgis.geometry, geom2 postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_distancecpa(postgis.geometry, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distancecpa(postgis.geometry, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_distancesphere(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distancesphere(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_distancespheroid(geom1 postgis.geometry, geom2 postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distancespheroid(geom1 postgis.geometry, geom2 postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_distinct4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distinct4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_distinct4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_distinct4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_dump(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dump(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_dumpaspolygons(rast postgis.raster, band integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dumpaspolygons(rast postgis.raster, band integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_dumppoints(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dumppoints(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_dumprings(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dumprings(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_dumpvalues(rast postgis.raster, nband integer[], exclude_nodata_value boolean, OUT nband integer, OUT valarray double precision[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dumpvalues(rast postgis.raster, nband integer[], exclude_nodata_value boolean, OUT nband integer, OUT valarray double precision[]) TO toaruser;


--
-- Name: FUNCTION st_dumpvalues(rast postgis.raster, nband integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dumpvalues(rast postgis.raster, nband integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_dwithin(text, text, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dwithin(text, text, double precision) TO toaruser;


--
-- Name: FUNCTION st_dwithin(postgis.geography, postgis.geography, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dwithin(postgis.geography, postgis.geography, double precision) TO toaruser;


--
-- Name: FUNCTION st_dwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dwithin(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_dwithin(rast1 postgis.raster, rast2 postgis.raster, distance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dwithin(rast1 postgis.raster, rast2 postgis.raster, distance double precision) TO toaruser;


--
-- Name: FUNCTION st_dwithin(postgis.geography, postgis.geography, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dwithin(postgis.geography, postgis.geography, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION st_dwithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_dwithin(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, distance double precision) TO toaruser;


--
-- Name: FUNCTION st_endpoint(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_endpoint(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_envelope(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_envelope(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_envelope(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_envelope(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_equals(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_equals(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_estimated_extent(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_estimated_extent(text, text) TO toaruser;


--
-- Name: FUNCTION st_estimated_extent(text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_estimated_extent(text, text, text) TO toaruser;


--
-- Name: FUNCTION st_estimatedextent(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_estimatedextent(text, text) TO toaruser;


--
-- Name: FUNCTION st_estimatedextent(text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_estimatedextent(text, text, text) TO toaruser;


--
-- Name: FUNCTION st_estimatedextent(text, text, text, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_estimatedextent(text, text, text, boolean) TO toaruser;


--
-- Name: FUNCTION st_expand(postgis.box2d, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_expand(postgis.box2d, double precision) TO toaruser;


--
-- Name: FUNCTION st_expand(postgis.box3d, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_expand(postgis.box3d, double precision) TO toaruser;


--
-- Name: FUNCTION st_expand(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_expand(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_expand(box postgis.box2d, dx double precision, dy double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_expand(box postgis.box2d, dx double precision, dy double precision) TO toaruser;


--
-- Name: FUNCTION st_expand(box postgis.box3d, dx double precision, dy double precision, dz double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_expand(box postgis.box3d, dx double precision, dy double precision, dz double precision) TO toaruser;


--
-- Name: FUNCTION st_expand(geom postgis.geometry, dx double precision, dy double precision, dz double precision, dm double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_expand(geom postgis.geometry, dx double precision, dy double precision, dz double precision, dm double precision) TO toaruser;


--
-- Name: FUNCTION st_exteriorring(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_exteriorring(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_find_extent(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_find_extent(text, text) TO toaruser;


--
-- Name: FUNCTION st_find_extent(text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_find_extent(text, text, text) TO toaruser;


--
-- Name: FUNCTION st_findextent(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_findextent(text, text) TO toaruser;


--
-- Name: FUNCTION st_findextent(text, text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_findextent(text, text, text) TO toaruser;


--
-- Name: FUNCTION st_flipcoordinates(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_flipcoordinates(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force2d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force2d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force3d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force3d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force3dm(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force3dm(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force3dz(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force3dz(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force4d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force4d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force_2d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force_2d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force_3d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force_3d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force_3dm(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force_3dm(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force_3dz(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force_3dz(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force_4d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force_4d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_force_collection(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_force_collection(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcecollection(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcecollection(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcecurve(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcecurve(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcepolygonccw(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcepolygonccw(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcepolygoncw(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcepolygoncw(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcerhr(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcerhr(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcesfs(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcesfs(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_forcesfs(postgis.geometry, version text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_forcesfs(postgis.geometry, version text) TO toaruser;


--
-- Name: FUNCTION st_frechetdistance(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_frechetdistance(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_fromgdalraster(gdaldata bytea, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_fromgdalraster(gdaldata bytea, srid integer) TO toaruser;


--
-- Name: FUNCTION st_gdaldrivers(OUT idx integer, OUT short_name text, OUT long_name text, OUT create_options text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_gdaldrivers(OUT idx integer, OUT short_name text, OUT long_name text, OUT create_options text) TO toaruser;


--
-- Name: FUNCTION st_generatepoints(area postgis.geometry, npoints numeric); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_generatepoints(area postgis.geometry, npoints numeric) TO toaruser;


--
-- Name: FUNCTION st_geogfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geogfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_geogfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geogfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_geographyfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geographyfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_geohash(geog postgis.geography, maxchars integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geohash(geog postgis.geography, maxchars integer) TO toaruser;


--
-- Name: FUNCTION st_geohash(geom postgis.geometry, maxchars integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geohash(geom postgis.geometry, maxchars integer) TO toaruser;


--
-- Name: FUNCTION st_geomcollfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomcollfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_geomcollfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomcollfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_geomcollfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomcollfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_geomcollfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomcollfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_geometricmedian(g postgis.geometry, tolerance double precision, max_iter integer, fail_if_not_converged boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geometricmedian(g postgis.geometry, tolerance double precision, max_iter integer, fail_if_not_converged boolean) TO toaruser;


--
-- Name: FUNCTION st_geometryfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geometryfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_geometryfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geometryfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_geometryn(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geometryn(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_geometrytype(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geometrytype(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_geomfromewkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromewkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_geomfromewkt(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromewkt(text) TO toaruser;


--
-- Name: FUNCTION st_geomfromgeohash(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromgeohash(text, integer) TO toaruser;


--
-- Name: FUNCTION st_geomfromgeojson(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromgeojson(text) TO toaruser;


--
-- Name: FUNCTION st_geomfromgml(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromgml(text) TO toaruser;


--
-- Name: FUNCTION st_geomfromgml(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromgml(text, integer) TO toaruser;


--
-- Name: FUNCTION st_geomfromkml(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromkml(text) TO toaruser;


--
-- Name: FUNCTION st_geomfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_geomfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_geomfromtwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromtwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_geomfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_geomfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geomfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_georeference(rast postgis.raster, format text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_georeference(rast postgis.raster, format text) TO toaruser;


--
-- Name: FUNCTION st_geotransform(postgis.raster, OUT imag double precision, OUT jmag double precision, OUT theta_i double precision, OUT theta_ij double precision, OUT xoffset double precision, OUT yoffset double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_geotransform(postgis.raster, OUT imag double precision, OUT jmag double precision, OUT theta_i double precision, OUT theta_ij double precision, OUT xoffset double precision, OUT yoffset double precision) TO toaruser;


--
-- Name: FUNCTION st_gmltosql(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_gmltosql(text) TO toaruser;


--
-- Name: FUNCTION st_gmltosql(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_gmltosql(text, integer) TO toaruser;


--
-- Name: FUNCTION st_hasarc(geometry postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_hasarc(geometry postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_hasnoband(rast postgis.raster, nband integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_hasnoband(rast postgis.raster, nband integer) TO toaruser;


--
-- Name: FUNCTION st_hausdorffdistance(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_hausdorffdistance(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_hausdorffdistance(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_hausdorffdistance(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_height(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_height(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_hillshade(rast postgis.raster, nband integer, pixeltype text, azimuth double precision, altitude double precision, max_bright double precision, scale double precision, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_hillshade(rast postgis.raster, nband integer, pixeltype text, azimuth double precision, altitude double precision, max_bright double precision, scale double precision, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_hillshade(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, azimuth double precision, altitude double precision, max_bright double precision, scale double precision, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_hillshade(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, azimuth double precision, altitude double precision, max_bright double precision, scale double precision, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_histogram(rast postgis.raster, nband integer, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rast postgis.raster, nband integer, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rastertable text, rastercolumn text, nband integer, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rastertable text, rastercolumn text, nband integer, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rast postgis.raster, nband integer, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rast postgis.raster, nband integer, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, bins integer, "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rastertable text, rastercolumn text, nband integer, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rastertable text, rastercolumn text, nband integer, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rast postgis.raster, nband integer, exclude_nodata_value boolean, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_histogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_histogram(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, bins integer, width double precision[], "right" boolean, OUT min double precision, OUT max double precision, OUT count bigint, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_interiorringn(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_interiorringn(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_interpolatepoint(line postgis.geometry, point postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_interpolatepoint(line postgis.geometry, point postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_intersection(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(text, text) TO toaruser;


--
-- Name: FUNCTION st_intersection(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_intersection(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast postgis.raster, geomin postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast postgis.raster, geomin postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_intersection(geomin postgis.geometry, rast postgis.raster, band integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(geomin postgis.geometry, rast postgis.raster, band integer) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast postgis.raster, band integer, geomin postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast postgis.raster, band integer, geomin postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, rast2 postgis.raster, nodataval double precision[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, rast2 postgis.raster, nodataval double precision[]) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, rast2 postgis.raster, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, rast2 postgis.raster, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, rast2 postgis.raster, returnband text, nodataval double precision[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, rast2 postgis.raster, returnband text, nodataval double precision[]) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, rast2 postgis.raster, returnband text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, rast2 postgis.raster, returnband text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, nodataval double precision[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, nodataval double precision[]) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, returnband text, nodataval double precision[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, returnband text, nodataval double precision[]) TO toaruser;


--
-- Name: FUNCTION st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, returnband text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersection(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, returnband text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_intersects(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(text, text) TO toaruser;


--
-- Name: FUNCTION st_intersects(postgis.geography, postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(postgis.geography, postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_intersects(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_intersects(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_intersects(geom postgis.geometry, rast postgis.raster, nband integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(geom postgis.geometry, rast postgis.raster, nband integer) TO toaruser;


--
-- Name: FUNCTION st_intersects(rast postgis.raster, nband integer, geom postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(rast postgis.raster, nband integer, geom postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_intersects(rast postgis.raster, geom postgis.geometry, nband integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(rast postgis.raster, geom postgis.geometry, nband integer) TO toaruser;


--
-- Name: FUNCTION st_intersects(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_intersects(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_invdistweight4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_invdistweight4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_isclosed(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isclosed(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_iscollection(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_iscollection(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_iscoveragetile(rast postgis.raster, coverage postgis.raster, tilewidth integer, tileheight integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_iscoveragetile(rast postgis.raster, coverage postgis.raster, tilewidth integer, tileheight integer) TO toaruser;


--
-- Name: FUNCTION st_isempty(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isempty(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_isempty(rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isempty(rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_ispolygonccw(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ispolygonccw(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_ispolygoncw(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ispolygoncw(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_isring(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isring(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_issimple(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_issimple(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_isvalid(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvalid(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_isvalid(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvalid(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_isvaliddetail(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvaliddetail(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_isvaliddetail(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvaliddetail(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_isvalidreason(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvalidreason(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_isvalidreason(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvalidreason(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_isvalidtrajectory(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_isvalidtrajectory(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_length(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length(text) TO toaruser;


--
-- Name: FUNCTION st_length(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_length(geog postgis.geography, use_spheroid boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length(geog postgis.geography, use_spheroid boolean) TO toaruser;


--
-- Name: FUNCTION st_length2d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length2d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_length2d_spheroid(postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length2d_spheroid(postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_length2dspheroid(postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length2dspheroid(postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_length_spheroid(postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_length_spheroid(postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_lengthspheroid(postgis.geometry, postgis.spheroid); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_lengthspheroid(postgis.geometry, postgis.spheroid) TO toaruser;


--
-- Name: FUNCTION st_line_interpolate_point(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_line_interpolate_point(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_line_locate_point(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_line_locate_point(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_line_substring(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_line_substring(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_linecrossingdirection(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linecrossingdirection(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_linefromencodedpolyline(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linefromencodedpolyline(text, integer) TO toaruser;


--
-- Name: FUNCTION st_linefrommultipoint(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linefrommultipoint(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_linefromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linefromtext(text) TO toaruser;


--
-- Name: FUNCTION st_linefromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linefromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_linefromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linefromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_linefromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linefromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_lineinterpolatepoint(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_lineinterpolatepoint(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_linelocatepoint(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linelocatepoint(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_linemerge(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linemerge(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_linestringfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linestringfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_linestringfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linestringfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_linesubstring(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linesubstring(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_linetocurve(geometry postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_linetocurve(geometry postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_locate_along_measure(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_locate_along_measure(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_locate_between_measures(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_locate_between_measures(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_locatealong(geometry postgis.geometry, measure double precision, leftrightoffset double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_locatealong(geometry postgis.geometry, measure double precision, leftrightoffset double precision) TO toaruser;


--
-- Name: FUNCTION st_locatebetween(geometry postgis.geometry, frommeasure double precision, tomeasure double precision, leftrightoffset double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_locatebetween(geometry postgis.geometry, frommeasure double precision, tomeasure double precision, leftrightoffset double precision) TO toaruser;


--
-- Name: FUNCTION st_locatebetweenelevations(geometry postgis.geometry, fromelevation double precision, toelevation double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_locatebetweenelevations(geometry postgis.geometry, fromelevation double precision, toelevation double precision) TO toaruser;


--
-- Name: FUNCTION st_longestline(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_longestline(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_m(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_m(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_makebox2d(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makebox2d(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_makeemptycoverage(tilewidth integer, tileheight integer, width integer, height integer, upperleftx double precision, upperlefty double precision, scalex double precision, scaley double precision, skewx double precision, skewy double precision, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeemptycoverage(tilewidth integer, tileheight integer, width integer, height integer, upperleftx double precision, upperlefty double precision, scalex double precision, scaley double precision, skewx double precision, skewy double precision, srid integer) TO toaruser;


--
-- Name: FUNCTION st_makeemptyraster(rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeemptyraster(rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_makeemptyraster(width integer, height integer, upperleftx double precision, upperlefty double precision, pixelsize double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeemptyraster(width integer, height integer, upperleftx double precision, upperlefty double precision, pixelsize double precision) TO toaruser;


--
-- Name: FUNCTION st_makeemptyraster(width integer, height integer, upperleftx double precision, upperlefty double precision, scalex double precision, scaley double precision, skewx double precision, skewy double precision, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeemptyraster(width integer, height integer, upperleftx double precision, upperlefty double precision, scalex double precision, scaley double precision, skewx double precision, skewy double precision, srid integer) TO toaruser;


--
-- Name: FUNCTION st_makeenvelope(double precision, double precision, double precision, double precision, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeenvelope(double precision, double precision, double precision, double precision, integer) TO toaruser;


--
-- Name: FUNCTION st_makeline(postgis.geometry[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeline(postgis.geometry[]) TO toaruser;


--
-- Name: FUNCTION st_makeline(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeline(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_makepoint(double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makepoint(double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_makepoint(double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makepoint(double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_makepoint(double precision, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makepoint(double precision, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_makepointm(double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makepointm(double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_makepolygon(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makepolygon(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_makepolygon(postgis.geometry, postgis.geometry[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makepolygon(postgis.geometry, postgis.geometry[]) TO toaruser;


--
-- Name: FUNCTION st_makevalid(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makevalid(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast postgis.raster, pixeltype text, expression text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast postgis.raster, pixeltype text, expression text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast postgis.raster, nband integer, pixeltype text, expression text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast postgis.raster, nband integer, pixeltype text, expression text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rastbandargset postgis.rastbandarg[], callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rastbandargset postgis.rastbandarg[], callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast1 postgis.raster, rast2 postgis.raster, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast1 postgis.raster, rast2 postgis.raster, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast postgis.raster, nband integer[], callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast postgis.raster, nband integer[], callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast postgis.raster, nband integer, callbackfunc regprocedure, mask double precision[], weighted boolean, pixeltype text, extenttype text, customextent postgis.raster, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast postgis.raster, nband integer, callbackfunc regprocedure, mask double precision[], weighted boolean, pixeltype text, extenttype text, customextent postgis.raster, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast postgis.raster, nband integer, callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast postgis.raster, nband integer, callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebra(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebra(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer, callbackfunc regprocedure, pixeltype text, extenttype text, customextent postgis.raster, distancex integer, distancey integer, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebraexpr(rast postgis.raster, pixeltype text, expression text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebraexpr(rast postgis.raster, pixeltype text, expression text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebraexpr(rast postgis.raster, band integer, pixeltype text, expression text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebraexpr(rast postgis.raster, band integer, pixeltype text, expression text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebraexpr(rast1 postgis.raster, rast2 postgis.raster, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebraexpr(rast1 postgis.raster, rast2 postgis.raster, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebraexpr(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebraexpr(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, expression text, pixeltype text, extenttype text, nodata1expr text, nodata2expr text, nodatanodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, onerastuserfunc regprocedure); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, onerastuserfunc regprocedure) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, band integer, onerastuserfunc regprocedure); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, band integer, onerastuserfunc regprocedure) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, onerastuserfunc regprocedure, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, onerastuserfunc regprocedure, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, pixeltype text, onerastuserfunc regprocedure); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, pixeltype text, onerastuserfunc regprocedure) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, band integer, onerastuserfunc regprocedure, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, band integer, onerastuserfunc regprocedure, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, band integer, pixeltype text, onerastuserfunc regprocedure); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, band integer, pixeltype text, onerastuserfunc regprocedure) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, pixeltype text, onerastuserfunc regprocedure, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, pixeltype text, onerastuserfunc regprocedure, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast postgis.raster, band integer, pixeltype text, onerastuserfunc regprocedure, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast postgis.raster, band integer, pixeltype text, onerastuserfunc regprocedure, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast1 postgis.raster, rast2 postgis.raster, tworastuserfunc regprocedure, pixeltype text, extenttype text, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast1 postgis.raster, rast2 postgis.raster, tworastuserfunc regprocedure, pixeltype text, extenttype text, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafct(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, tworastuserfunc regprocedure, pixeltype text, extenttype text, VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafct(rast1 postgis.raster, band1 integer, rast2 postgis.raster, band2 integer, tworastuserfunc regprocedure, pixeltype text, extenttype text, VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mapalgebrafctngb(rast postgis.raster, band integer, pixeltype text, ngbwidth integer, ngbheight integer, onerastngbuserfunc regprocedure, nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mapalgebrafctngb(rast postgis.raster, band integer, pixeltype text, ngbwidth integer, ngbheight integer, onerastngbuserfunc regprocedure, nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_max4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_max4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_max4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_max4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_maxdistance(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_maxdistance(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_mean4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mean4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_mean4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mean4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_mem_size(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mem_size(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_memsize(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_memsize(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_memsize(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_memsize(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_metadata(rast postgis.raster, OUT upperleftx double precision, OUT upperlefty double precision, OUT width integer, OUT height integer, OUT scalex double precision, OUT scaley double precision, OUT skewx double precision, OUT skewy double precision, OUT srid integer, OUT numbands integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_metadata(rast postgis.raster, OUT upperleftx double precision, OUT upperlefty double precision, OUT width integer, OUT height integer, OUT scalex double precision, OUT scaley double precision, OUT skewx double precision, OUT skewy double precision, OUT srid integer, OUT numbands integer) TO toaruser;


--
-- Name: FUNCTION st_min4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_min4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_min4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_min4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_minconvexhull(rast postgis.raster, nband integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_minconvexhull(rast postgis.raster, nband integer) TO toaruser;


--
-- Name: FUNCTION st_mindist4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mindist4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_minimumboundingcircle(inputgeom postgis.geometry, segs_per_quarter integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_minimumboundingcircle(inputgeom postgis.geometry, segs_per_quarter integer) TO toaruser;


--
-- Name: FUNCTION st_minimumboundingradius(postgis.geometry, OUT center postgis.geometry, OUT radius double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_minimumboundingradius(postgis.geometry, OUT center postgis.geometry, OUT radius double precision) TO toaruser;


--
-- Name: FUNCTION st_minimumclearance(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_minimumclearance(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_minimumclearanceline(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_minimumclearanceline(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_minpossiblevalue(pixeltype text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_minpossiblevalue(pixeltype text) TO toaruser;


--
-- Name: FUNCTION st_mlinefromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mlinefromtext(text) TO toaruser;


--
-- Name: FUNCTION st_mlinefromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mlinefromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_mlinefromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mlinefromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_mlinefromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mlinefromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_mpointfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpointfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_mpointfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpointfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_mpointfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpointfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_mpointfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpointfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_mpolyfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpolyfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_mpolyfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpolyfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_mpolyfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpolyfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_mpolyfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_mpolyfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_multi(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multi(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_multilinefromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multilinefromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_multilinestringfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multilinestringfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_multilinestringfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multilinestringfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_multipointfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipointfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_multipointfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipointfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_multipointfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipointfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_multipolyfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipolyfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_multipolyfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipolyfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_multipolygonfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipolygonfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_multipolygonfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_multipolygonfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_ndims(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ndims(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_nearestvalue(rast postgis.raster, pt postgis.geometry, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_nearestvalue(rast postgis.raster, pt postgis.geometry, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_nearestvalue(rast postgis.raster, columnx integer, rowy integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_nearestvalue(rast postgis.raster, columnx integer, rowy integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_nearestvalue(rast postgis.raster, band integer, pt postgis.geometry, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_nearestvalue(rast postgis.raster, band integer, pt postgis.geometry, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_nearestvalue(rast postgis.raster, band integer, columnx integer, rowy integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_nearestvalue(rast postgis.raster, band integer, columnx integer, rowy integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_neighborhood(rast postgis.raster, pt postgis.geometry, distancex integer, distancey integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_neighborhood(rast postgis.raster, pt postgis.geometry, distancex integer, distancey integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_neighborhood(rast postgis.raster, columnx integer, rowy integer, distancex integer, distancey integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_neighborhood(rast postgis.raster, columnx integer, rowy integer, distancex integer, distancey integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_neighborhood(rast postgis.raster, band integer, pt postgis.geometry, distancex integer, distancey integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_neighborhood(rast postgis.raster, band integer, pt postgis.geometry, distancex integer, distancey integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_neighborhood(rast postgis.raster, band integer, columnx integer, rowy integer, distancex integer, distancey integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_neighborhood(rast postgis.raster, band integer, columnx integer, rowy integer, distancex integer, distancey integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_node(g postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_node(g postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_normalize(geom postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_normalize(geom postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_notsamealignmentreason(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_notsamealignmentreason(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_npoints(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_npoints(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_nrings(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_nrings(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_numbands(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_numbands(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_numgeometries(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_numgeometries(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_numinteriorring(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_numinteriorring(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_numinteriorrings(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_numinteriorrings(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_numpatches(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_numpatches(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_numpoints(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_numpoints(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_offsetcurve(line postgis.geometry, distance double precision, params text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_offsetcurve(line postgis.geometry, distance double precision, params text) TO toaruser;


--
-- Name: FUNCTION st_orderingequals(geometrya postgis.geometry, geometryb postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_orderingequals(geometrya postgis.geometry, geometryb postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_overlaps(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_overlaps(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_overlaps(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_overlaps(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_overlaps(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_overlaps(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_patchn(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_patchn(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_perimeter(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_perimeter(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_perimeter(geog postgis.geography, use_spheroid boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_perimeter(geog postgis.geography, use_spheroid boolean) TO toaruser;


--
-- Name: FUNCTION st_perimeter2d(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_perimeter2d(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_pixelascentroid(rast postgis.raster, x integer, y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelascentroid(rast postgis.raster, x integer, y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelascentroids(rast postgis.raster, band integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelascentroids(rast postgis.raster, band integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelaspoint(rast postgis.raster, x integer, y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelaspoint(rast postgis.raster, x integer, y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelaspoints(rast postgis.raster, band integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelaspoints(rast postgis.raster, band integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelaspolygon(rast postgis.raster, x integer, y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelaspolygon(rast postgis.raster, x integer, y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelaspolygons(rast postgis.raster, band integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelaspolygons(rast postgis.raster, band integer, exclude_nodata_value boolean, OUT geom postgis.geometry, OUT val double precision, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelheight(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelheight(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_pixelofvalue(rast postgis.raster, search double precision[], exclude_nodata_value boolean, OUT val double precision, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelofvalue(rast postgis.raster, search double precision[], exclude_nodata_value boolean, OUT val double precision, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelofvalue(rast postgis.raster, search double precision, exclude_nodata_value boolean, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelofvalue(rast postgis.raster, search double precision, exclude_nodata_value boolean, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelofvalue(rast postgis.raster, nband integer, search double precision[], exclude_nodata_value boolean, OUT val double precision, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelofvalue(rast postgis.raster, nband integer, search double precision[], exclude_nodata_value boolean, OUT val double precision, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelofvalue(rast postgis.raster, nband integer, search double precision, exclude_nodata_value boolean, OUT x integer, OUT y integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelofvalue(rast postgis.raster, nband integer, search double precision, exclude_nodata_value boolean, OUT x integer, OUT y integer) TO toaruser;


--
-- Name: FUNCTION st_pixelwidth(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pixelwidth(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_point(double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_point(double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_point_inside_circle(postgis.geometry, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_point_inside_circle(postgis.geometry, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_pointfromgeohash(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointfromgeohash(text, integer) TO toaruser;


--
-- Name: FUNCTION st_pointfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_pointfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_pointfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_pointfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_pointinsidecircle(postgis.geometry, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointinsidecircle(postgis.geometry, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_pointn(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointn(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_pointonsurface(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_pointonsurface(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_points(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_points(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_polyfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polyfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_polyfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polyfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_polyfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polyfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_polyfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polyfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_polygon(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygon(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_polygon(rast postgis.raster, band integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygon(rast postgis.raster, band integer) TO toaruser;


--
-- Name: FUNCTION st_polygonfromtext(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygonfromtext(text) TO toaruser;


--
-- Name: FUNCTION st_polygonfromtext(text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygonfromtext(text, integer) TO toaruser;


--
-- Name: FUNCTION st_polygonfromwkb(bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygonfromwkb(bytea) TO toaruser;


--
-- Name: FUNCTION st_polygonfromwkb(bytea, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygonfromwkb(bytea, integer) TO toaruser;


--
-- Name: FUNCTION st_polygonize(postgis.geometry[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygonize(postgis.geometry[]) TO toaruser;


--
-- Name: FUNCTION st_project(geog postgis.geography, distance double precision, azimuth double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_project(geog postgis.geography, distance double precision, azimuth double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, exclude_nodata_value boolean, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, exclude_nodata_value boolean, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, nband integer, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, nband integer, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, nband integer, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, nband integer, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, exclude_nodata_value boolean, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, exclude_nodata_value boolean, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, nband integer, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, nband integer, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, nband integer, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, nband integer, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rast postgis.raster, nband integer, exclude_nodata_value boolean, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, quantiles double precision[], OUT quantile double precision, OUT value double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, quantiles double precision[], OUT quantile double precision, OUT value double precision) TO toaruser;


--
-- Name: FUNCTION st_quantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, quantile double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_quantile(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, quantile double precision) TO toaruser;


--
-- Name: FUNCTION st_range4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_range4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_range4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_range4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_rastertoworldcoord(rast postgis.raster, columnx integer, rowy integer, OUT longitude double precision, OUT latitude double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rastertoworldcoord(rast postgis.raster, columnx integer, rowy integer, OUT longitude double precision, OUT latitude double precision) TO toaruser;


--
-- Name: FUNCTION st_rastertoworldcoordx(rast postgis.raster, xr integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rastertoworldcoordx(rast postgis.raster, xr integer) TO toaruser;


--
-- Name: FUNCTION st_rastertoworldcoordx(rast postgis.raster, xr integer, yr integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rastertoworldcoordx(rast postgis.raster, xr integer, yr integer) TO toaruser;


--
-- Name: FUNCTION st_rastertoworldcoordy(rast postgis.raster, yr integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rastertoworldcoordy(rast postgis.raster, yr integer) TO toaruser;


--
-- Name: FUNCTION st_rastertoworldcoordy(rast postgis.raster, xr integer, yr integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rastertoworldcoordy(rast postgis.raster, xr integer, yr integer) TO toaruser;


--
-- Name: FUNCTION st_reclass(rast postgis.raster, VARIADIC reclassargset postgis.reclassarg[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_reclass(rast postgis.raster, VARIADIC reclassargset postgis.reclassarg[]) TO toaruser;


--
-- Name: FUNCTION st_reclass(rast postgis.raster, reclassexpr text, pixeltype text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_reclass(rast postgis.raster, reclassexpr text, pixeltype text) TO toaruser;


--
-- Name: FUNCTION st_reclass(rast postgis.raster, nband integer, reclassexpr text, pixeltype text, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_reclass(rast postgis.raster, nband integer, reclassexpr text, pixeltype text, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_relate(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_relate(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_relate(geom1 postgis.geometry, geom2 postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_relate(geom1 postgis.geometry, geom2 postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_relate(geom1 postgis.geometry, geom2 postgis.geometry, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_relate(geom1 postgis.geometry, geom2 postgis.geometry, text) TO toaruser;


--
-- Name: FUNCTION st_relatematch(text, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_relatematch(text, text) TO toaruser;


--
-- Name: FUNCTION st_removepoint(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_removepoint(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_removerepeatedpoints(geom postgis.geometry, tolerance double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_removerepeatedpoints(geom postgis.geometry, tolerance double precision) TO toaruser;


--
-- Name: FUNCTION st_resample(rast postgis.raster, ref postgis.raster, usescale boolean, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resample(rast postgis.raster, ref postgis.raster, usescale boolean, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_resample(rast postgis.raster, ref postgis.raster, algorithm text, maxerr double precision, usescale boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resample(rast postgis.raster, ref postgis.raster, algorithm text, maxerr double precision, usescale boolean) TO toaruser;


--
-- Name: FUNCTION st_resample(rast postgis.raster, scalex double precision, scaley double precision, gridx double precision, gridy double precision, skewx double precision, skewy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resample(rast postgis.raster, scalex double precision, scaley double precision, gridx double precision, gridy double precision, skewx double precision, skewy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_resample(rast postgis.raster, width integer, height integer, gridx double precision, gridy double precision, skewx double precision, skewy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resample(rast postgis.raster, width integer, height integer, gridx double precision, gridy double precision, skewx double precision, skewy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_rescale(rast postgis.raster, scalexy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rescale(rast postgis.raster, scalexy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_rescale(rast postgis.raster, scalex double precision, scaley double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rescale(rast postgis.raster, scalex double precision, scaley double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_resize(rast postgis.raster, percentwidth double precision, percentheight double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resize(rast postgis.raster, percentwidth double precision, percentheight double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_resize(rast postgis.raster, width integer, height integer, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resize(rast postgis.raster, width integer, height integer, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_resize(rast postgis.raster, width text, height text, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_resize(rast postgis.raster, width text, height text, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_reskew(rast postgis.raster, skewxy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_reskew(rast postgis.raster, skewxy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_reskew(rast postgis.raster, skewx double precision, skewy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_reskew(rast postgis.raster, skewx double precision, skewy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_retile(tab regclass, col name, ext postgis.geometry, sfx double precision, sfy double precision, tw integer, th integer, algo text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_retile(tab regclass, col name, ext postgis.geometry, sfx double precision, sfy double precision, tw integer, th integer, algo text) TO toaruser;


--
-- Name: FUNCTION st_reverse(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_reverse(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_rotate(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotate(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_rotate(postgis.geometry, double precision, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotate(postgis.geometry, double precision, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_rotate(postgis.geometry, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotate(postgis.geometry, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_rotatex(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotatex(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_rotatey(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotatey(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_rotatez(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotatez(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_rotation(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_rotation(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_roughness(rast postgis.raster, nband integer, pixeltype text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_roughness(rast postgis.raster, nband integer, pixeltype text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_roughness(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_roughness(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_samealignment(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_samealignment(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_samealignment(ulx1 double precision, uly1 double precision, scalex1 double precision, scaley1 double precision, skewx1 double precision, skewy1 double precision, ulx2 double precision, uly2 double precision, scalex2 double precision, scaley2 double precision, skewx2 double precision, skewy2 double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_samealignment(ulx1 double precision, uly1 double precision, scalex1 double precision, scaley1 double precision, skewx1 double precision, skewy1 double precision, ulx2 double precision, uly2 double precision, scalex2 double precision, scaley2 double precision, skewx2 double precision, skewy2 double precision) TO toaruser;


--
-- Name: FUNCTION st_scale(postgis.geometry, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_scale(postgis.geometry, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_scale(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_scale(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_scale(postgis.geometry, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_scale(postgis.geometry, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_scalex(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_scalex(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_scaley(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_scaley(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_segmentize(geog postgis.geography, max_segment_length double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_segmentize(geog postgis.geography, max_segment_length double precision) TO toaruser;


--
-- Name: FUNCTION st_segmentize(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_segmentize(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_setbandisnodata(rast postgis.raster, band integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setbandisnodata(rast postgis.raster, band integer) TO toaruser;


--
-- Name: FUNCTION st_setbandnodatavalue(rast postgis.raster, nodatavalue double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setbandnodatavalue(rast postgis.raster, nodatavalue double precision) TO toaruser;


--
-- Name: FUNCTION st_setbandnodatavalue(rast postgis.raster, band integer, nodatavalue double precision, forcechecking boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setbandnodatavalue(rast postgis.raster, band integer, nodatavalue double precision, forcechecking boolean) TO toaruser;


--
-- Name: FUNCTION st_seteffectivearea(postgis.geometry, double precision, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_seteffectivearea(postgis.geometry, double precision, integer) TO toaruser;


--
-- Name: FUNCTION st_setgeoreference(rast postgis.raster, georef text, format text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setgeoreference(rast postgis.raster, georef text, format text) TO toaruser;


--
-- Name: FUNCTION st_setgeoreference(rast postgis.raster, upperleftx double precision, upperlefty double precision, scalex double precision, scaley double precision, skewx double precision, skewy double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setgeoreference(rast postgis.raster, upperleftx double precision, upperlefty double precision, scalex double precision, scaley double precision, skewx double precision, skewy double precision) TO toaruser;


--
-- Name: FUNCTION st_setgeotransform(rast postgis.raster, imag double precision, jmag double precision, theta_i double precision, theta_ij double precision, xoffset double precision, yoffset double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setgeotransform(rast postgis.raster, imag double precision, jmag double precision, theta_i double precision, theta_ij double precision, xoffset double precision, yoffset double precision) TO toaruser;


--
-- Name: FUNCTION st_setpoint(postgis.geometry, integer, postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setpoint(postgis.geometry, integer, postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_setrotation(rast postgis.raster, rotation double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setrotation(rast postgis.raster, rotation double precision) TO toaruser;


--
-- Name: FUNCTION st_setscale(rast postgis.raster, scale double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setscale(rast postgis.raster, scale double precision) TO toaruser;


--
-- Name: FUNCTION st_setscale(rast postgis.raster, scalex double precision, scaley double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setscale(rast postgis.raster, scalex double precision, scaley double precision) TO toaruser;


--
-- Name: FUNCTION st_setskew(rast postgis.raster, skew double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setskew(rast postgis.raster, skew double precision) TO toaruser;


--
-- Name: FUNCTION st_setskew(rast postgis.raster, skewx double precision, skewy double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setskew(rast postgis.raster, skewx double precision, skewy double precision) TO toaruser;


--
-- Name: FUNCTION st_setsrid(geog postgis.geography, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setsrid(geog postgis.geography, srid integer) TO toaruser;


--
-- Name: FUNCTION st_setsrid(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setsrid(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_setsrid(rast postgis.raster, srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setsrid(rast postgis.raster, srid integer) TO toaruser;


--
-- Name: FUNCTION st_setupperleft(rast postgis.raster, upperleftx double precision, upperlefty double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setupperleft(rast postgis.raster, upperleftx double precision, upperlefty double precision) TO toaruser;


--
-- Name: FUNCTION st_setvalue(rast postgis.raster, geom postgis.geometry, newvalue double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalue(rast postgis.raster, geom postgis.geometry, newvalue double precision) TO toaruser;


--
-- Name: FUNCTION st_setvalue(rast postgis.raster, x integer, y integer, newvalue double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalue(rast postgis.raster, x integer, y integer, newvalue double precision) TO toaruser;


--
-- Name: FUNCTION st_setvalue(rast postgis.raster, nband integer, geom postgis.geometry, newvalue double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalue(rast postgis.raster, nband integer, geom postgis.geometry, newvalue double precision) TO toaruser;


--
-- Name: FUNCTION st_setvalue(rast postgis.raster, band integer, x integer, y integer, newvalue double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalue(rast postgis.raster, band integer, x integer, y integer, newvalue double precision) TO toaruser;


--
-- Name: FUNCTION st_setvalues(rast postgis.raster, nband integer, geomvalset postgis.geomval[], keepnodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalues(rast postgis.raster, nband integer, geomvalset postgis.geomval[], keepnodata boolean) TO toaruser;


--
-- Name: FUNCTION st_setvalues(rast postgis.raster, nband integer, x integer, y integer, newvalueset double precision[], noset boolean[], keepnodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalues(rast postgis.raster, nband integer, x integer, y integer, newvalueset double precision[], noset boolean[], keepnodata boolean) TO toaruser;


--
-- Name: FUNCTION st_setvalues(rast postgis.raster, nband integer, x integer, y integer, newvalueset double precision[], nosetvalue double precision, keepnodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalues(rast postgis.raster, nband integer, x integer, y integer, newvalueset double precision[], nosetvalue double precision, keepnodata boolean) TO toaruser;


--
-- Name: FUNCTION st_setvalues(rast postgis.raster, x integer, y integer, width integer, height integer, newvalue double precision, keepnodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalues(rast postgis.raster, x integer, y integer, width integer, height integer, newvalue double precision, keepnodata boolean) TO toaruser;


--
-- Name: FUNCTION st_setvalues(rast postgis.raster, nband integer, x integer, y integer, width integer, height integer, newvalue double precision, keepnodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_setvalues(rast postgis.raster, nband integer, x integer, y integer, width integer, height integer, newvalue double precision, keepnodata boolean) TO toaruser;


--
-- Name: FUNCTION st_sharedpaths(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_sharedpaths(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_shift_longitude(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_shift_longitude(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_shiftlongitude(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_shiftlongitude(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_shortestline(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_shortestline(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_simplify(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_simplify(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_simplify(postgis.geometry, double precision, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_simplify(postgis.geometry, double precision, boolean) TO toaruser;


--
-- Name: FUNCTION st_simplifypreservetopology(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_simplifypreservetopology(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_simplifyvw(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_simplifyvw(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_skewx(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_skewx(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_skewy(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_skewy(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_slope(rast postgis.raster, nband integer, pixeltype text, units text, scale double precision, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_slope(rast postgis.raster, nband integer, pixeltype text, units text, scale double precision, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_slope(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, units text, scale double precision, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_slope(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, units text, scale double precision, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_snap(geom1 postgis.geometry, geom2 postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snap(geom1 postgis.geometry, geom2 postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(postgis.geometry, double precision, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(postgis.geometry, double precision, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(geom1 postgis.geometry, geom2 postgis.geometry, double precision, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(geom1 postgis.geometry, geom2 postgis.geometry, double precision, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(rast postgis.raster, gridx double precision, gridy double precision, scalexy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(rast postgis.raster, gridx double precision, gridy double precision, scalexy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(rast postgis.raster, gridx double precision, gridy double precision, scalex double precision, scaley double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(rast postgis.raster, gridx double precision, gridy double precision, scalex double precision, scaley double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_snaptogrid(rast postgis.raster, gridx double precision, gridy double precision, algorithm text, maxerr double precision, scalex double precision, scaley double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_snaptogrid(rast postgis.raster, gridx double precision, gridy double precision, algorithm text, maxerr double precision, scalex double precision, scaley double precision) TO toaruser;


--
-- Name: FUNCTION st_split(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_split(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_srid(geog postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_srid(geog postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_srid(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_srid(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_srid(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_srid(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_startpoint(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_startpoint(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_stddev4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_stddev4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_stddev4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_stddev4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_subdivide(geom postgis.geometry, maxvertices integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_subdivide(geom postgis.geometry, maxvertices integer) TO toaruser;


--
-- Name: FUNCTION st_sum4ma(value double precision[], pos integer[], VARIADIC userargs text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_sum4ma(value double precision[], pos integer[], VARIADIC userargs text[]) TO toaruser;


--
-- Name: FUNCTION st_sum4ma(matrix double precision[], nodatamode text, VARIADIC args text[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_sum4ma(matrix double precision[], nodatamode text, VARIADIC args text[]) TO toaruser;


--
-- Name: FUNCTION st_summary(postgis.geography); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summary(postgis.geography) TO toaruser;


--
-- Name: FUNCTION st_summary(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summary(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_summary(rast postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summary(rast postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_summarystats(rast postgis.raster, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystats(rast postgis.raster, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_summarystats(rastertable text, rastercolumn text, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystats(rastertable text, rastercolumn text, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_summarystats(rast postgis.raster, nband integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystats(rast postgis.raster, nband integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_summarystats(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystats(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_swapordinates(geom postgis.geometry, ords cstring); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_swapordinates(geom postgis.geometry, ords cstring) TO toaruser;


--
-- Name: FUNCTION st_symdifference(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_symdifference(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_symmetricdifference(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_symmetricdifference(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_tile(rast postgis.raster, width integer, height integer, padwithnodata boolean, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tile(rast postgis.raster, width integer, height integer, padwithnodata boolean, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_tile(rast postgis.raster, nband integer[], width integer, height integer, padwithnodata boolean, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tile(rast postgis.raster, nband integer[], width integer, height integer, padwithnodata boolean, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_tile(rast postgis.raster, nband integer, width integer, height integer, padwithnodata boolean, nodataval double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tile(rast postgis.raster, nband integer, width integer, height integer, padwithnodata boolean, nodataval double precision) TO toaruser;


--
-- Name: FUNCTION st_touches(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_touches(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_touches(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_touches(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_touches(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_touches(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_tpi(rast postgis.raster, nband integer, pixeltype text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tpi(rast postgis.raster, nband integer, pixeltype text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_tpi(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tpi(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_transform(postgis.geometry, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(postgis.geometry, integer) TO toaruser;


--
-- Name: FUNCTION st_transform(geom postgis.geometry, to_proj text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(geom postgis.geometry, to_proj text) TO toaruser;


--
-- Name: FUNCTION st_transform(geom postgis.geometry, from_proj text, to_srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(geom postgis.geometry, from_proj text, to_srid integer) TO toaruser;


--
-- Name: FUNCTION st_transform(geom postgis.geometry, from_proj text, to_proj text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(geom postgis.geometry, from_proj text, to_proj text) TO toaruser;


--
-- Name: FUNCTION st_transform(rast postgis.raster, alignto postgis.raster, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(rast postgis.raster, alignto postgis.raster, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_transform(rast postgis.raster, srid integer, scalexy double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(rast postgis.raster, srid integer, scalexy double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_transform(rast postgis.raster, srid integer, scalex double precision, scaley double precision, algorithm text, maxerr double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(rast postgis.raster, srid integer, scalex double precision, scaley double precision, algorithm text, maxerr double precision) TO toaruser;


--
-- Name: FUNCTION st_transform(rast postgis.raster, srid integer, algorithm text, maxerr double precision, scalex double precision, scaley double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transform(rast postgis.raster, srid integer, algorithm text, maxerr double precision, scalex double precision, scaley double precision) TO toaruser;


--
-- Name: FUNCTION st_translate(postgis.geometry, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_translate(postgis.geometry, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_translate(postgis.geometry, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_translate(postgis.geometry, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_transscale(postgis.geometry, double precision, double precision, double precision, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_transscale(postgis.geometry, double precision, double precision, double precision, double precision) TO toaruser;


--
-- Name: FUNCTION st_tri(rast postgis.raster, nband integer, pixeltype text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tri(rast postgis.raster, nband integer, pixeltype text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_tri(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, interpolate_nodata boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_tri(rast postgis.raster, nband integer, customextent postgis.raster, pixeltype text, interpolate_nodata boolean) TO toaruser;


--
-- Name: FUNCTION st_unaryunion(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_unaryunion(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.geometry[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.geometry[]) TO toaruser;


--
-- Name: FUNCTION st_union(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_upperleftx(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_upperleftx(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_upperlefty(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_upperlefty(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_value(rast postgis.raster, pt postgis.geometry, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_value(rast postgis.raster, pt postgis.geometry, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_value(rast postgis.raster, x integer, y integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_value(rast postgis.raster, x integer, y integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_value(rast postgis.raster, band integer, pt postgis.geometry, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_value(rast postgis.raster, band integer, pt postgis.geometry, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_value(rast postgis.raster, band integer, x integer, y integer, exclude_nodata_value boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_value(rast postgis.raster, band integer, x integer, y integer, exclude_nodata_value boolean) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rast postgis.raster, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rast postgis.raster, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rast postgis.raster, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rast postgis.raster, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rastertable text, rastercolumn text, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rastertable text, rastercolumn text, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rastertable text, rastercolumn text, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rastertable text, rastercolumn text, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rast postgis.raster, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rast postgis.raster, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rast postgis.raster, nband integer, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rast postgis.raster, nband integer, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rastertable text, rastercolumn text, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rastertable text, rastercolumn text, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rastertable text, rastercolumn text, nband integer, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rastertable text, rastercolumn text, nband integer, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT count integer) TO toaruser;


--
-- Name: FUNCTION st_valuecount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuecount(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rast postgis.raster, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rast postgis.raster, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rast postgis.raster, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rast postgis.raster, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rastertable text, rastercolumn text, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rastertable text, rastercolumn text, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rastertable text, rastercolumn text, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rastertable text, rastercolumn text, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rast postgis.raster, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rast postgis.raster, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rast postgis.raster, nband integer, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rast postgis.raster, nband integer, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rastertable text, rastercolumn text, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rastertable text, rastercolumn text, nband integer, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rastertable text, rastercolumn text, nband integer, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rastertable text, rastercolumn text, nband integer, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rast postgis.raster, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalues double precision[], roundto double precision, OUT value double precision, OUT percent double precision) TO toaruser;


--
-- Name: FUNCTION st_valuepercent(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_valuepercent(rastertable text, rastercolumn text, nband integer, exclude_nodata_value boolean, searchvalue double precision, roundto double precision) TO toaruser;


--
-- Name: FUNCTION st_voronoilines(g1 postgis.geometry, tolerance double precision, extend_to postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_voronoilines(g1 postgis.geometry, tolerance double precision, extend_to postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_voronoipolygons(g1 postgis.geometry, tolerance double precision, extend_to postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_voronoipolygons(g1 postgis.geometry, tolerance double precision, extend_to postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_width(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_width(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_within(geom1 postgis.geometry, geom2 postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_within(geom1 postgis.geometry, geom2 postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_within(rast1 postgis.raster, rast2 postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_within(rast1 postgis.raster, rast2 postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_within(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_within(rast1 postgis.raster, nband1 integer, rast2 postgis.raster, nband2 integer) TO toaruser;


--
-- Name: FUNCTION st_wkbtosql(wkb bytea); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_wkbtosql(wkb bytea) TO toaruser;


--
-- Name: FUNCTION st_wkttosql(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_wkttosql(text) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoord(rast postgis.raster, pt postgis.geometry, OUT columnx integer, OUT rowy integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoord(rast postgis.raster, pt postgis.geometry, OUT columnx integer, OUT rowy integer) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoord(rast postgis.raster, longitude double precision, latitude double precision, OUT columnx integer, OUT rowy integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoord(rast postgis.raster, longitude double precision, latitude double precision, OUT columnx integer, OUT rowy integer) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoordx(rast postgis.raster, xw double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoordx(rast postgis.raster, xw double precision) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoordx(rast postgis.raster, pt postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoordx(rast postgis.raster, pt postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoordx(rast postgis.raster, xw double precision, yw double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoordx(rast postgis.raster, xw double precision, yw double precision) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoordy(rast postgis.raster, yw double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoordy(rast postgis.raster, yw double precision) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoordy(rast postgis.raster, pt postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoordy(rast postgis.raster, pt postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_worldtorastercoordy(rast postgis.raster, xw double precision, yw double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_worldtorastercoordy(rast postgis.raster, xw double precision, yw double precision) TO toaruser;


--
-- Name: FUNCTION st_wrapx(geom postgis.geometry, wrap double precision, move double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_wrapx(geom postgis.geometry, wrap double precision, move double precision) TO toaruser;


--
-- Name: FUNCTION st_x(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_x(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_xmax(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_xmax(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION st_xmin(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_xmin(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION st_y(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_y(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_ymax(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ymax(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION st_ymin(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_ymin(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION st_z(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_z(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_zmax(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_zmax(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION st_zmflag(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_zmflag(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_zmin(postgis.box3d); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_zmin(postgis.box3d) TO toaruser;


--
-- Name: FUNCTION text(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.text(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION unlockrows(text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.unlockrows(text) TO toaruser;


--
-- Name: FUNCTION updategeometrysrid(character varying, character varying, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.updategeometrysrid(character varying, character varying, integer) TO toaruser;


--
-- Name: FUNCTION updategeometrysrid(character varying, character varying, character varying, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.updategeometrysrid(character varying, character varying, character varying, integer) TO toaruser;


--
-- Name: FUNCTION updategeometrysrid(catalogn_name character varying, schema_name character varying, table_name character varying, column_name character varying, new_srid_in integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.updategeometrysrid(catalogn_name character varying, schema_name character varying, table_name character varying, column_name character varying, new_srid_in integer) TO toaruser;


--
-- Name: FUNCTION updaterastersrid(table_name name, column_name name, new_srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.updaterastersrid(table_name name, column_name name, new_srid integer) TO toaruser;


--
-- Name: FUNCTION updaterastersrid(schema_name name, table_name name, column_name name, new_srid integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.updaterastersrid(schema_name name, table_name name, column_name name, new_srid integer) TO toaruser;


--
-- Name: FUNCTION st_3dextent(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_3dextent(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_accum(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_accum(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_asgeobuf(anyelement); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeobuf(anyelement) TO toaruser;


--
-- Name: FUNCTION st_asgeobuf(anyelement, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asgeobuf(anyelement, text) TO toaruser;


--
-- Name: FUNCTION st_asmvt(anyelement); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asmvt(anyelement) TO toaruser;


--
-- Name: FUNCTION st_asmvt(anyelement, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asmvt(anyelement, text) TO toaruser;


--
-- Name: FUNCTION st_asmvt(anyelement, text, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asmvt(anyelement, text, integer) TO toaruser;


--
-- Name: FUNCTION st_asmvt(anyelement, text, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_asmvt(anyelement, text, integer, text) TO toaruser;


--
-- Name: FUNCTION st_clusterintersecting(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clusterintersecting(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_clusterwithin(postgis.geometry, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_clusterwithin(postgis.geometry, double precision) TO toaruser;


--
-- Name: FUNCTION st_collect(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_collect(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_countagg(postgis.raster, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_countagg(postgis.raster, boolean) TO toaruser;


--
-- Name: FUNCTION st_countagg(postgis.raster, integer, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_countagg(postgis.raster, integer, boolean) TO toaruser;


--
-- Name: FUNCTION st_countagg(postgis.raster, integer, boolean, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_countagg(postgis.raster, integer, boolean, double precision) TO toaruser;


--
-- Name: FUNCTION st_extent(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_extent(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_makeline(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_makeline(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_memcollect(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_memcollect(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_memunion(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_memunion(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_polygonize(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_polygonize(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_samealignment(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_samealignment(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_summarystatsagg(postgis.raster, boolean, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystatsagg(postgis.raster, boolean, double precision) TO toaruser;


--
-- Name: FUNCTION st_summarystatsagg(postgis.raster, integer, boolean); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystatsagg(postgis.raster, integer, boolean) TO toaruser;


--
-- Name: FUNCTION st_summarystatsagg(postgis.raster, integer, boolean, double precision); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_summarystatsagg(postgis.raster, integer, boolean, double precision) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.geometry); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.geometry) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.raster); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.raster) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.raster, integer); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.raster, integer) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.raster, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.raster, text) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.raster, postgis.unionarg[]); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.raster, postgis.unionarg[]) TO toaruser;


--
-- Name: FUNCTION st_union(postgis.raster, integer, text); Type: ACL; Schema: postgis; Owner: toarcurator
--

GRANT ALL ON FUNCTION postgis.st_union(postgis.raster, integer, text) TO toaruser;


--
-- Name: TABLE at_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.at_vocabulary TO toaruser;


--
-- Name: TABLE auth_user; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.auth_user TO toaruser;


--
-- Name: TABLE contacts; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.contacts TO toaruser;


--
-- Name: SEQUENCE contacts_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.contacts_id_seq TO toaruser;


--
-- Name: TABLE cv_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.cv_vocabulary TO toaruser;


--
-- Name: TABLE cz_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.cz_vocabulary TO toaruser;


--
-- Name: TABLE da_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.da_vocabulary TO toaruser;


--
-- Name: TABLE data; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.data TO toaruser;


--
-- Name: TABLE df_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.df_vocabulary TO toaruser;


--
-- Name: TABLE dl_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.dl_vocabulary TO toaruser;


--
-- Name: TABLE ds_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.ds_vocabulary TO toaruser;


--
-- Name: TABLE mm_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.mm_vocabulary TO toaruser;


--
-- Name: TABLE ok_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.ok_vocabulary TO toaruser;


--
-- Name: TABLE organisations; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.organisations TO toaruser;


--
-- Name: SEQUENCE organisations_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.organisations_id_seq TO toaruser;


--
-- Name: TABLE persons; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.persons TO toaruser;


--
-- Name: SEQUENCE persons_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.persons_id_seq TO toaruser;


--
-- Name: TABLE rc_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.rc_vocabulary TO toaruser;


--
-- Name: TABLE rs_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.rs_vocabulary TO toaruser;


--
-- Name: TABLE rt_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.rt_vocabulary TO toaruser;


--
-- Name: TABLE sf_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.sf_vocabulary TO toaruser;


--
-- Name: TABLE st_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.st_vocabulary TO toaruser;


--
-- Name: TABLE stationmeta_annotations; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_annotations TO toaruser;


--
-- Name: SEQUENCE stationmeta_annotations_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_annotations_id_seq TO toaruser;


--
-- Name: TABLE stationmeta_aux_doc; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_aux_doc TO toaruser;


--
-- Name: TABLE stationmeta_aux_image; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_aux_image TO toaruser;


--
-- Name: SEQUENCE stationmeta_aux_image_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_aux_image_id_seq TO toaruser;


--
-- Name: TABLE stationmeta_aux_url; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_aux_url TO toaruser;


--
-- Name: SEQUENCE stationmeta_aux_url_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_aux_url_id_seq TO toaruser;


--
-- Name: TABLE stationmeta_core; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_core TO toaruser;


--
-- Name: SEQUENCE stationmeta_core_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_core_id_seq TO toaruser;


--
-- Name: TABLE stationmeta_core_stationmeta_annotations; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_core_stationmeta_annotations TO toaruser;


--
-- Name: TABLE stationmeta_core_stationmeta_roles; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_core_stationmeta_roles TO toaruser;


--
-- Name: TABLE stationmeta_global; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_global TO toaruser;


--
-- Name: SEQUENCE stationmeta_global_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_global_id_seq TO toaruser;


--
-- Name: TABLE stationmeta_global_services; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_global_services TO toaruser;


--
-- Name: SEQUENCE stationmeta_global_services_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_global_services_id_seq TO toaruser;


--
-- Name: TABLE stationmeta_roles; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.stationmeta_roles TO toaruser;


--
-- Name: SEQUENCE stationmeta_roles_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.stationmeta_roles_id_seq TO toaruser;


--
-- Name: TABLE ta_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.ta_vocabulary TO toaruser;


--
-- Name: TABLE tc_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.tc_vocabulary TO toaruser;


--
-- Name: TABLE timeseries; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.timeseries TO toaruser;


--
-- Name: TABLE timeseries_annotations; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.timeseries_annotations TO toaruser;


--
-- Name: SEQUENCE timeseries_annotations_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.timeseries_annotations_id_seq TO toaruser;


--
-- Name: SEQUENCE timeseries_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.timeseries_id_seq TO toaruser;


--
-- Name: TABLE timeseries_programmes; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.timeseries_programmes TO toaruser;


--
-- Name: SEQUENCE timeseries_programmes_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.timeseries_programmes_id_seq TO toaruser;


--
-- Name: TABLE timeseries_roles; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.timeseries_roles TO toaruser;


--
-- Name: SEQUENCE timeseries_roles_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.timeseries_roles_id_seq TO toaruser;


--
-- Name: TABLE timeseries_timeseries_annotations; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.timeseries_timeseries_annotations TO toaruser;


--
-- Name: TABLE timeseries_timeseries_roles; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.timeseries_timeseries_roles TO toaruser;


--
-- Name: TABLE tr_vocabulary; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.tr_vocabulary TO toaruser;


--
-- Name: TABLE us_gaz; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.us_gaz TO toaruser;


--
-- Name: TABLE us_lex; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.us_lex TO toaruser;


--
-- Name: TABLE us_rules; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT ON TABLE public.us_rules TO toaruser;


--
-- Name: TABLE variables; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT SELECT,INSERT,UPDATE ON TABLE public.variables TO toaruser;


--
-- Name: SEQUENCE variables_id_seq; Type: ACL; Schema: public; Owner: toarcurator
--

GRANT UPDATE ON SEQUENCE public.variables_id_seq TO toaruser;


--
-- PostgreSQL database dump complete
--

